#
#  This will convert a floating point value in xmm0 register to an ASCII string
#  and then append it to the current output buffer.
#
# rdi is output buffer address variable
# rsi is output buffer position variable
# rdx is output zone variable
# xmm0 is real number to append
#
        .type   .Lappendfloat, @function
.Lappendfloat:
        pushq   %rbp                # create stack frame
        movq    %rsp, %rbp
        subq    $64,%rsp            # allocate room for local variables
                                    # -8(%rbp)   address of output buffer
                                    # -16(%rbp)  address of output bufpos
                                    # -24(%rbp)  address of output zonepos
                                    # -56(%rbp)  32 byte tbuffer
                                    # -64(%rbp)  8 byte padding to keep 16 byte alignment
        movq    %rdi,-8(%rbp)       # output buffer address variable
        movq    %rsi,-16(%rbp)      # output buffer position variable
        movq    %rdx,-24(%rbp)      # output zone variable
        .if .LBITS64==0
        subq    $8,%rsp             # add 8 bytes padding to keep 16 byte alignment
        movq    %xmm0,%rax          # save backup copy of xmm0
        pushq   %rax
        cvtss2sd %xmm0,%xmm0        # xmm0=(double)xmm0
        .endif
        leaq    -56(%rbp), %rdi     # rdi is address of tbuffer
        movl    $.LSIGNIFICANCE_WIDTH-1, %esi  # number of digits after decimal point
        movl    $.LEXRAD_WIDTH, %edx           # number of digits in exponent
        movabsq $.Lg_fmt, %rax      # call g_fmt(tbuffer, xmm0, SIGNIFICANCE_WIDTH-1,EXRAD_WIDTH)
        callq   *%rax               # leaving result in buffer whose address is in rax
        .if .LBITS64==0
        popq    %rcx                # restore original value of xmm0
        movq    %rcx,%xmm0          # must use rcx, not rax, since rax contains
                                    # address of buffer with result of g_fmt
        addq    $8,%rsp             # remove 8 bytes padding to keep 16 byte alignment
        .endif
        movq    %rax,%rcx           # rcx = address of tbuffer
        movq    -8(%rbp),%rdi       # output buffer variable address
        movq    -16(%rbp),%rsi      # output bufpos variable address
        movq    -24(%rbp),%rdx      # output zonepos variable address
        movabsq $.Lappendbuffer, %rax # call appendbuffer
        callq   *%rax
        addq    $64,%rsp            # deallocate local variables and padding
        movq    %rbp,%rsp           # destroy stack frame
        popq    %rbp
        retq
        .size .Lappendfloat, .-.Lappendfloat
