        .att_syntax
        .att_mnemonic
        .arch core2,nojumps
        .if .LSSE4_1==1
        .arch .sse4.1
        .endif
        .code64
        .if .LBITS64==1  # if we are using 8-byte doubles
        .equiv .LBALIGN, 8            # we need (at least) 8-byte alignment
        .equiv .LBYTES_IN_NUMBER, 8   # a 64 bit IEEE754 double
        .equiv .LFLOATONE,        0x3ff0000000000000  #  1.0
        .equiv .LFLOATNEGONE,     0xbff0000000000000  # -1.0
        .equiv .LFLOATHALF,       0x3fe0000000000000  #  0.5
        .equiv .LFLOATNEGHALF,    0xbfe0000000000000  # -0.5
        .equiv .LFLOATTEN,        0x4024000000000000  # 10.0
        .equiv .LQNaN_Indefinite, 0xfff8000000000000  # Indefinite NaN
        .equiv .LNaN,             0x7ff8000000000000  # NaN
        .equiv .LSNaN,            0x7ff0000000000001  # Signalling NaN
        .equiv .LPInf,            0x7ff0000000000000  # +INF
        .equiv .LNInf,            0xfff0000000000000  # -INF
        .equiv .LPI,              0x400921fb54442d18  # pi 3.141592653589793238462643383279502884L
        .equiv .LPIOVER180,       0x3f91df46a2529d39  # pi/180.0
        .equiv .L180OVERPI,       0x404ca5dc1a63c1f8  # 180.0/pi
        .equiv .LMAXNORMAL,       0x7FEFFFFFFFFFFFFF  # 2^1024*(1-2^53), approximately 1.7976931348623157E+308
        .else           # we are using 4-byte floats
        .equiv .LBALIGN, 4            # we need (at least) 4-byte alignment
        .equiv .LBYTES_IN_NUMBER, 4   # a 32 bit IEEE754 float
        .equiv .LFLOATONE,        0x3f800000          #  1.0f
        .equiv .LFLOATNEGONE,     0xbf800000          # -1.0f
        .equiv .LFLOATHALF,       0x3f000000          #  0.5f
        .equiv .LFLOATNEGHALF,    0xbf000000          # -0.5f
        .equiv .LFLOATTEN,        0x41200000          # 10.0f
        .equiv .LQNaN_Indefinite, 0xffc00000          # Indefinite NaN
        .equiv .LNaN,             0x7fc00000          # NaN
        .equiv .LSNaN,            0x7fa00000          # Signalling NaN
        .equiv .LPInf,            0x7f800000          # +INF
        .equiv .LNInf,            0xff800000          # -INF
        .equiv .LPI,              0x40490fdb          # pi 3.141592653589793238462643383279502884
        .equiv .LPIOVER180,       0x3c8efa35          # pi/180.0
        .equiv .L180OVERPI,       0x42652ee1          # 180.0/pi
        .equiv .LMAXNORMAL,       0x7F7FFFFF          # 2^128*(1-2^24), approximately 3.4028234663852886E+38
        .endif
         # we need 64bit version of +INF always
        .equiv .LPInf64,          0x7ff0000000000000  # 8-byte double +INF
        .equiv .LNInf64,          0xfff0000000000000  # -INF
        .equiv .LFLOATONE64,      0x3ff0000000000000  #  1.0
        .equiv .LFLOATNEGONE64,   0xbff0000000000000  # -1.0
        .equiv .LINT_Indefinite,  0x8000000000000000
        .equiv .LEXIT_SUCCESS, 0
        .equiv .LEXIT_FAILURE, 1
        .equiv .LSPACE, 32
        .equiv .LCOMMA, 44
        .equiv .LNAK, 21
        .equiv .LEIGHT_NAK, 0x1515151515151515        # 8 NAK bytes
        .equiv .LEDOM, 33
        .equiv .LERANGE, 34
        .equiv .LNEWLINE, 10
        .equiv .LFE_INVALID, 0x01
        .equiv .LFE_DENORM, 0x02
        .equiv .LFE_DIVBYZERO, 0x04
        .equiv .LFE_OVERFLOW, 0x08
        .equiv .LFE_UNDERFLOW, 0x10
        .equiv .LFE_INEXACT, 0x20
        .equiv .LFE_ALL_EXCEPT, (.LFE_INEXACT | .LFE_DIVBYZERO | .LFE_UNDERFLOW | .LFE_OVERFLOW | .LFE_INVALID)
        .equiv .LFE_TONEAREST, 0x000
        .equiv .LFE_DOWNWARD, 0x400
        .equiv .LFE_UPWARD, 0x800
        .equiv .LFE_TOWARDZERO, 0xc00
        .equiv .LSTDIN, 0
        .equiv .LSTDOUT, 1
        .equiv .LSTDERR, 2
        .equiv .L__NR_write, 1
        .equiv .L__NR_exit, 60
        .equiv .LLT, 0
        .equiv .LLE, 1
        .equiv .LEQ, 2
        .equiv .LGE, 3
        .equiv .LGT, 4
        .equiv .LNE, 5
        .equiv .LQSTR, 0
        .equiv .LNUM, 1
        .equiv .LUQSTR, 2
