        .section .rodata.str,"aS",@progbits

        .type .Lnocmov, @object
.Lnocmov:
        .asciz "CPU LACKS REQUIRED SUPPORT FOR CMOV INSTRUCTION.\n"
        .size .Lnocmov, .-.Lnocmov
        .set .Lnocmovlen, .-.Lnocmov

        .type .Lnosse2, @object
.Lnosse2:
        .asciz "CPU LACKS REQUIRED SUPPORT FOR SSE2 INSTRUCTIONS.\n"
        .size .Lnosse2, .-.Lnosse2
        .set .Lnosse2len, .-.Lnosse2

        .type .Lnosse3, @object
.Lnosse3:
        .asciz "CPU LACKS REQUIRED SUPPORT FOR SSE3 INSTRUCTIONS.\n"
        .size .Lnosse3, .-.Lnosse3
        .set .Lnosse3len, .-.Lnosse3

        .type .Lnossse3, @object
.Lnossse3:
        .asciz "CPU LACKS REQUIRED SUPPORT FOR SSSE3 INSTRUCTIONS.\n"
        .size .Lnossse3, .-.Lnossse3
        .set .Lnossse3len, .-.Lnossse3

        .type .Lnofxsr, @object
.Lnofxsr:
        .asciz "CPU LACKS REQUIRED SUPPORT FOR FXSR INSTRUCTIONS.\n"
        .size .Lnofxsr, .-.Lnofxsr
        .set .Lnofxsrlen, .-.Lnofxsr

        .if .LSSE4_1==1
        .type .Lnosse4_1, @object
.Lnosse4_1:
        .asciz "CPU LACKS REQUIRED SUPPORT FOR SSE4.1 INSTRUCTIONS BUT YOU SPECIFIED\n"
        .asciz "THE -4 OR THE -A COMPILER OPTION.\n"
        .size .Lnosse4_1, .-.Lnosse4_1
        .set .Lnosse4_1len, .-.Lnosse4_1
        .endif

        .section .text,"ax",@progbits

        # no args, returns 1 in rax if required features detected, 0 otherwise
        # required features are SSE2, SSE3, SSSE3, CMOV
        # this routine WILL print error messages to .LSTDERR, but is quiet on success
        # Note: there are two retq, one for success, one for failure
        .type   .Lhavefeatures, @function
.Lhavefeatures:
        movl    $1,%eax        # get leaf #1
        cpuid                  # of CPUID information
        btl     $26,%edx       # if we have SSE2 support
        jc      0f             # then goto 0
        movl    $.Lnosse2len,%edx  # rdx = length of error message
        movabsq $.Lnosse2,%rsi     # rsi = address of error message
        {disp8} jmp 10f        # goto 10
0:      btl     $24,%edx       # if we have FXSR support
        jc      1f             # then goto 1
        movl    $.Lnofxsrlen,%edx  # rdx = length of error message
        movabsq $.Lnofxsr,%rsi     # rsi = address of error message
        {disp8} jmp 10f        # goto 10
1:      btl     $0,%ecx        # if we have SSE3 support
        jc      2f             # then goto 2
        movl    $.Lnosse3len,%edx  # rdx = length of error message
        movabsq $.Lnosse3,%rsi     # rsi = address of error message
        {disp8} jmp 10f        # goto 10
2:      btl     $9,%ecx        # if we have SSSE3 support
        jc      3f             # then goto 3
        movl    $.Lnossse3len,%edx  # rdx = length of error message
        movabsq $.Lnossse3,%rsi     # rsi = address of error message
        {disp8} jmp 10f        # goto 10
3:      btl     $15,%edx       # if we have CMOV support
        jc      6f             # then goto 6
        movl    $.Lnocmovlen,%edx  # rdx = length of error message
        movabsq $.Lnocmov,%rsi     # rsi = address of error message
        {disp8} jmp 10f        # goto 10
6:
        .if .LSSE4_1==1        # if the user specified -4
        btl     $19,%ecx       # if we have SSE4.1 support
        jc      7f             # then goto 7
        movl    $.Lnosse4_1len,%edx # rdx = length of error message
        movabsq $.Lnosse4_1,%rsi    # rsi = address of error message
        {disp8} jmp 10f        # goto 10
7:
        .endif
        # fallthrough successful return point
        movl    $1,%eax                 # return 1
        retq
10:     # error return point
        movl    $.LSTDERR,%edi          # write error message to
        movl    $.L__NR_write,%eax      # STDERR using low-level
        syscall                         # kernel call
        xorl    %eax,%eax               # return 0
        retq
        .size .Lhavefeatures, .-.Lhavefeatures
