#       .equiv .LSTDIN, 0
        .equiv .L__NR_fstat, 5
        .equiv .LS_IFMT, 00170000   # OCTAL
        .equiv .LS_IFCHR, 0020000   # OCTAL

        .section .bss,"aw",@nobits

        .balign 4,0
#
# buf is a struct stat from /usr/src/linux*/arch/x86/include/uapi/asm/stat.h
#
#  struct stat {
#      __kernel_ulong_t    st_dev;
#      __kernel_ulong_t    st_ino;
#      __kernel_ulong_t    st_nlink;
#      unsigned int        st_mode;
#      unsigned int        st_uid;
#      unsigned int        st_gid;
#      unsigned int        __pad0;
#      __kernel_ulong_t    st_rdev;
#      __kernel_long_t     st_size;
#      __kernel_long_t     st_blksize;
#      __kernel_long_t     st_blocks;  /* Number 512-byte blocks allocated. */
#      __kernel_ulong_t    st_atime;
#      __kernel_ulong_t    st_atime_nsec;
#      __kernel_ulong_t    st_mtime;
#      __kernel_ulong_t    st_mtime_nsec;
#      __kernel_ulong_t    st_ctime;
#      __kernel_ulong_t    st_ctime_nsec;
#      __kernel_long_t     __unused[3];
#  };
#
        .type   .Lstatbuf, @object
.Lstatbuf:
        .zero   144
        .size   .Lstatbuf, .-.Lstatbuf

        .section .text,"ax",@progbits

#
# This Linux-specific function takes no arguments, and is used
# to determined if .LSTDIN is a tty or not.  It returns a value in rax:
#
#  0 if .LSTDIN is not a tty
#  1 if .LSTDIN is a tty
#
        .type   .Listerminal, @function
.Listerminal:
        pushq   %rdi
        pushq   %rsi
        movl    $.LSTDIN, %edi       # rdi = .LSTDIN
        movabsq $.Lstatbuf, %rsi     # rsi = statbuf
        movl    $.L__NR_fstat, %eax  # rax = __NR_fstat
        syscall                      # call fstat on .LSTDIN
        movabsq $.Lstatbuf, %rax     # rax = statbuf
        movl    24(%rax), %eax       # eax = statbuf.st_mode
        andl    $.LS_IFMT, %eax      # eax &= S_IFMT
        cmpl    $.LS_IFCHR, %eax     # if (eax==S_IFCHR) then
        sete    %al                  # al=1 else al=0
        movzbl  %al, %eax            # rax = al (return value)
        popq    %rsi
        popq    %rdi
        retq
        .size   .Listerminal, .-.Listerminal
