        .section .bss,"aw",@nobits

#
# derived from C code of public domain tzcode from Greg Olson
#
        .align 32
        .type   .Lgetenv_buffer, @object
.Lgetenv_buffer:
        .zero 65536
        .size .Lgetenv_buffer, .-.Lgetenv_buffer

        .section .text,"ax",@progbits

        # char *getenv(const char *name)
        # name passed in rax, result returned in rax
        # NULL returned if name not found
        # uses .Lgetenv_buffer which has a maximum buffer
        # of 64KB for a single environment entry
        # uses environemnt as read-only pointer to
        # environment variable list passed at program start
        .p2align 4
        .type   .Lgetenv, @function
.Lgetenv:
        movq    %rdi, %r8
        movabsq $.Lenvironment, %rax
        movq    (%rax), %rax
        testq   %rax,%rax
        jne     0f
        retq
0:
        movq    (%rax), %rdx
        movabsq $.Lgetenv_buffer, %r10
        leaq    -1(%r10), %r11
        testq   %rdx, %rdx
        jne     8f
        {disp8} jmp 9f
1:
        movl    %edi, %ecx
        movb    $0, (%r10,%rcx)
        movzbl  (%r10), %ecx
        movq    %r8, %rsi
        xorl    %r9d, %r9d
        testb   %cl, %cl
        je      4f
        movabsq $.Lgetenv_buffer, %r9
2:
        cmpb    %cl, (%rsi)
        je      3f
        movl    %ecx, %r9d
        {disp8} jmp 4f
3:
        addq    $1, %r9
        addq    $1, %rsi
        movzbl  (%r9), %ecx
        testb   %cl, %cl
        jne     2b
        xorl    %r9d, %r9d
4:
        cmpb    (%rsi), %r9b
        je      6f
        {disp8} jmp 7f
5:
        movb    %sil, (%r11,%rcx)
        movl    %ecx, %edi
        addq    $1, %rcx
        movzbl  -1(%rdx,%rcx), %esi
        cmpb    $61, %sil
        je      1b
        {disp8} jmp 5b
6:
        leal    1(%rdi), %eax
        addq    %rdx, %rax
        retq
7:
        addq    $8, %rax
        movq    (%rax), %rdx
        testq   %rdx, %rdx
        je      9f
8:
        movzbl  (%rdx), %esi
        xorl    %edi, %edi
        movl    $1, %ecx
        cmpb    $61, %sil
        jne     5b
        {disp8} jmp 1b
9:
        xorl    %eax, %eax
        retq
        .size   .Lgetenv, .-.Lgetenv

        .p2align 4
        .type   .Ltypesequiv, @function
.Ltypesequiv:
        movq    %rdi, %rcx
        testq   %rdi, %rdi
        sete    %al
        movl    %esi, %edi
        shrl    $31, %edi
        orb     %dil, %al
        je      1f
        xorl    %eax, %eax
0:
        retq
1:
        cmpl    %edx, %esi
        movl    %edx, %edi
        cmovge  %esi, %edi
        cmpl    %edi, 8(%rcx)
        setle   %dil
        movl    %edx, %r8d
        shrl    $31, %r8d
        orb     %r8b, %dil
        jne     0b
        movslq  %esi, %rsi
        leaq    (%rsi,%rsi,2), %rax
        leaq    (%rcx,%rax,8), %rsi
        movslq  %edx, %rdx
        leaq    (%rdx,%rdx,2), %rax
        leaq    (%rcx,%rax,8), %rax
        movq    18024(%rax), %rdx
        cmpq    %rdx, 18024(%rsi)
        jne     3f
        movzbl  18032(%rax), %edx
        cmpb    %dl, 18032(%rsi)
        jne     3f
        movzwl  18040(%rax), %edx
        cmpw    %dx, 18040(%rsi)
        jne     3f
        movslq  18036(%rsi), %rdx
        movzbl  24168(%rcx,%rdx), %esi
        movslq  18036(%rax), %r8
        movzbl  24168(%rcx,%r8), %eax
        cmpb    %al, %sil
        jne     3f
        leaq    24168(%rcx,%r8), %r8
        leaq    24168(%rcx,%rdx), %rcx
        movl    $1, %edx
2:
        testb   %sil, %sil
        je      4f
        movzbl  (%rcx,%rdx), %esi
        addq    $1, %rdx
        movzbl  -1(%r8,%rdx), %eax
        cmpb    %al, %sil
        je      2b
3:
        movl    %edi, %eax
        retq
4:
        testb   %al, %al
        sete    %dil
        movl    %edi, %eax
        retq
        .size   .Ltypesequiv, .-.Ltypesequiv

        .p2align 4
        .type   .Ltranstime, @function
.Ltranstime:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r12
        pushq   %rbx
        movl    %edi, %r9d
        movq    %rsi, %rcx
        movq    %rdx, %r8
        testb   $3, %dil
        jne     4f
        imull   $-1030792151, %edi, %eax
        addl    $85899344, %eax
        movl    %eax, %edx
        rorl    $2, %edx
        cmpl    $42949672, %edx
        jbe     3f
0:
        movl    (%rcx), %edx
        cmpl    $2, %edx
        je      12f
        movl    $0, %eax
        ja      2f
        testl   %edx, %edx
        je      13f
1:
        movslq  4(%rcx), %rax
        imulq   $86400, %rax, %rax
2:
        addq    16(%rcx), %rax
        addq    %r8, %rax
        popq    %rbx
        popq    %r12
        popq    %rbp
        retq
3:
        rorl    $4, %eax
        cmpl    $10737418, %eax
        jbe     0b
4:
        movl    (%rcx), %edx
        cmpl    $2, %edx
        jne     11f
        xorl    %esi, %esi
5:
        movl    12(%rcx), %edi
        xorl    %eax, %eax
        cmpl    $3, %edi
        setl    %al
        subl    %eax, %r9d
        movslq  %r9d, %rdx
        imulq   $1374389535, %rdx, %rdx
        movq    %rdx, %rax
        sarq    $37, %rax
        movq    %rax, %r10
        movl    %r9d, %ebx
        sarl    $31, %ebx
        movl    %eax, %r11d
        subl    %ebx, %r11d
        imull   $100, %r11d, %eax
        movl    %r9d, %r11d
        subl    %eax, %r11d
        leal    9(%rdi), %eax
        movslq  %eax, %r9
        imulq   $715827883, %r9, %r9
        sarq    $33, %r9
        movl    %eax, %r12d
        sarl    $31, %r12d
        subl    %r12d, %r9d
        leal    (%r9,%r9,2), %r9d
        sall    $2, %r9d
        subl    %r9d, %eax
        addl    $1, %eax
        imull   $26, %eax, %eax
        subl    $2, %eax
        movslq  %eax, %r9
        imulq   $1717986919, %r9, %r9
        sarq    $34, %r9
        sarl    $31, %eax
        subl    %eax, %r9d
        leal    1(%r11,%r9), %eax
        leal    3(%r11), %r9d
        testl   %r11d, %r11d
        cmovns  %r11d, %r9d
        sarl    $2, %r9d
        addl    %r9d, %eax
        sarq    $39, %rdx
        subl    %ebx, %edx
        addl    %edx, %eax
        subl    %ebx, %r10d
        addl    %r10d, %r10d
        subl    %r10d, %eax
        movslq  %eax, %rdx
        imulq   $-1840700269, %rdx, %rdx
        shrq    $32, %rdx
        addl    %eax, %edx
        sarl    $2, %edx
        movl    %eax, %r9d
        sarl    $31, %r9d
        subl    %r9d, %edx
        leal    0(,%rdx,8), %r9d
        subl    %edx, %r9d
        subl    %r9d, %eax
        movl    %eax, %edx
        leal    7(%rax), %eax
        cmovs   %eax, %edx
        movl    4(%rcx), %eax
        subl    %edx, %eax
        leal    7(%rax), %edx
        cmovs   %edx, %eax
        movl    8(%rcx), %r9d
        leal    -1(%rdi), %r10d
        cmpl    $1, %r9d
        jle     7f
        movslq  %r10d, %rdx
        movslq  %esi, %r11
        leaq    (%r11,%r11,2), %r11
        leaq    (%rdx,%r11,4), %r11
        movabsq $.Lmon_lengths, %rdx
        movl    (%rdx,%r11,4), %r11d
        leal    0(,%r9,8), %edx
        subl    %r9d, %edx
        leal    -7(%rax,%rdx), %r9d
        movl    %eax, %edx
6:
        movl    %edx, %eax
        leal    7(%rdx), %edx
        cmpl    %r11d, %edx
        jl      10f
7:
        cltq
        imulq   $86400, %rax, %rax
        testl   %r10d, %r10d
        jle     2b
8:
        leaq    (%rsi,%rsi,2), %rsi
        movq    %rsi, %rdx
        salq    $4, %rdx
        movabsq $.Lmon_lengths, %r9
        addq    %r9, %rdx
        subl    $2, %edi
        leaq    (%rdi,%rsi,4), %rdi
        leaq    4(%r9), %rsi
        leaq    (%rsi,%rdi,4), %rdi
9:
        movslq  (%rdx), %rsi
        imulq   $86400, %rsi, %rsi
        addq    %rsi, %rax
        addq    $4, %rdx
        cmpq    %rdx, %rdi
        jne     9b
        addq    16(%rcx), %rax
        addq    %r8, %rax
        popq    %rbx
        popq    %r12
        popq    %rbp
        retq
10:
        cmpl    %r9d, %edx
        jne     6b
        movl    %edx, %eax
        cltq
        imulq   $86400, %rax, %rax
        testl   %r10d, %r10d
        jle     2b
        jmp     8b
11:
        movl    $0, %eax
        ja      2b
        testl   %edx, %edx
        jne     1b
        movl    4(%rcx), %eax
        subl    $1, %eax
        cltq
        imulq   $86400, %rax, %rax
        addq    16(%rcx), %rax
        addq    %r8, %rax
        popq    %rbx
        popq    %r12
        popq    %rbp
        retq
12:
        movl    $1, %esi
        jmp     5b
13:
        movl    4(%rcx), %edx
        leal    -1(%rdx), %eax
        cltq
        imulq   $86400, %rax, %rax
        leaq    86400(%rax), %rsi
        cmpl    $59, %edx
        cmovg   %rsi, %rax
        addq    16(%rcx), %rax
        addq    %r8, %rax
        popq    %rbx
        popq    %r12
        popq    %rbp
        retq
        .size   .Ltranstime, .-.Ltranstime

        .p2align 4
        .type   .Ltimesub, @function
.Ltimesub:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        movq    %rsi, -48(%rbp)
        movq    %rdx, %rax
        movq    %rcx, %r8
        movq    (%rdi), %r11
        xorl    %r9d, %r9d
        xorl    %ebx, %ebx
        testq   %rdx, %rdx
        je      1f
        movslq  (%rdx), %rdx
        movq    %rdx, %rcx
        salq    $4, %rdx
        addq    %rax, %rdx
0:
        subl    $1, %ecx
        js      39f
        subq    $16, %rdx
        movq    24680(%rdx), %rsi
        cmpq    %r11, %rsi
        jg      0b
        movslq  %ecx, %rdx
        addq    $1542, %rdx
        salq    $4, %rdx
        addq    %rdx, %rax
        movq    16(%rax), %rbx
        xorl    %r9d, %r9d
        cmpq    %r11, %rsi
        je      40f
1:
        movabsq $1749024623285053783, %rdx
        movq    %r11, %rax
        imulq   %rdx
        sarq    $13, %rdx
        movq    %r11, %rax
        sarq    $63, %rax
        movq    %rdx, %rcx
        subq    %rax, %rcx
        movl    $1970, %esi
        movl    $2147483648, %r12d
2:
        testq   %rcx, %rcx
        jns     7f
3:
        movabsq $3225660165894566403, %rax
        imulq   %rcx
        sarq    $6, %rdx
        movq    %rcx, %rdi
        sarq    $63, %rdi
        subq    %rdi, %rdx
        leaq    (%rdx,%r12), %rax
        movl    $4294967295, %r14d
        cmpq    %r14, %rax
        ja      29f
        orl     $1, %edi
        testq   %rdx, %rdx
        cmovne  %edx, %edi
        movl    $-2147483648, %eax
        subl    %esi, %eax
        cmpl    %eax, %edi
        setl    %al
        testl   %esi, %esi
        js      4f
        movl    $2147483647, %eax
        subl    %esi, %eax
        cmpl    %eax, %edi
        setg    %al
4:
        testb   %al, %al
        jne     29f
        leal    (%rdi,%rsi), %eax
        movl    %eax, %r13d
        subl    $1, %r13d
        jns     37f
        movl    %eax, %r13d
        negl    %r13d
        movl    %r13d, %edx
        sarl    $2, %edx
        movslq  %r13d, %r10
        imulq   $1374389535, %r10, %r10
        movq    %r10, %r14
        sarq    $37, %r14
        sarl    $31, %r13d
        movl    %r13d, %r15d
        subl    %r14d, %r15d
        addl    %r15d, %edx
        sarq    $39, %r10
        subl    %r13d, %r10d
        addl    %r10d, %edx
        notl    %edx
        movl    %esi, %r13d
        subl    $1, %r13d
        jns     38f
5:
        negl    %esi
        movl    %esi, %r10d
        sarl    $2, %r10d
        movslq  %esi, %r13
        imulq   $1374389535, %r13, %r13
        movq    %r13, %r14
        sarq    $37, %r14
        sarl    $31, %esi
        movl    %esi, %r15d
        subl    %r14d, %r15d
        addl    %r15d, %r10d
        sarq    $39, %r13
        subl    %esi, %r13d
        leal    (%r10,%r13), %esi
        notl    %esi
6:
        movslq  %edi, %rdi
        imulq   $-365, %rdi, %rdi
        addq    %rcx, %rdi
        subl    %esi, %edx
        movslq  %edx, %rdx
        subq    %rdx, %rdi
        movq    %rdi, %rcx
        movl    %eax, %esi
        jmp     2b
7:
        movl    $365, %edx
        testb   $3, %sil
        jne     8f
        imull   $-1030792151, %esi, %eax
        addl    $85899344, %eax
        movl    %eax, %edi
        rorl    $2, %edi
        movl    $366, %edx
        cmpl    $42949672, %edi
        jbe     32f
8:
        cmpq    %rdx, %rcx
        jge     3b
9:
        movabsq $1749024623285053783, %rdx
        movq    %r11, %rax
        imulq   %rdx
        sarq    $13, %rdx
        movq    %r11, %rax
        sarq    $63, %rax
        subq    %rax, %rdx
        imulq   $86400, %rdx, %rax
        movq    %r11, %rdx
        subq    %rax, %rdx
        movq    -48(%rbp), %rdi
        subq    %rbx, %rdi
        addq    %rdx, %rdi
        jns     13f
10:
        subl    $1, %ecx
        addq    $86400, %rdi
        js      10b
        testl   %ecx, %ecx
        js      35f
11:
        movabsq $.Lyear_lengths, %r11
        movl    $2147483647, %edx
12:
        movl    %esi, %r10d
        andl    $3, %r10d
        jne     15f
        imull   $-1030792151, %esi, %eax
        addl    $85899344, %eax
        rorl    $2, %eax
        cmpl    $42949672, %eax
        jbe     18f
        cmpl    $365, %ecx
        jle     19f
        movl    $366, %eax
        jmp     16f
13:
        cmpq    $86399, %rdi
        jle     11b
14:
        subq    $86400, %rdi
        addl    $1, %ecx
        cmpq    $86399, %rdi
        jg      14b
        jmp     11b
15:
        cmpl    $364, %ecx
        jle     19f
        movl    $365, %eax
16:
        testl   %esi, %esi
        js      17f
        movl    %edx, %r10d
        subl    %esi, %r10d
        testl   %r10d, %r10d
        jle     29f
17:
        subl    %eax, %ecx
        addl    $1, %esi
        jmp     12b
18:
        movslq  %esi, %rax
        imulq   $1374389535, %rax, %rax
        sarq    $39, %rax
        movl    %esi, %ebx
        sarl    $31, %ebx
        subl    %ebx, %eax
        imull   $400, %eax, %ebx
        movl    %esi, %eax
        subl    %ebx, %eax
        jne     30f
        cmpl    $365, %ecx
        jg      31f
19:
        testl   %esi, %esi
        js      20f
        leal    -1900(%rsi), %eax
        movl    %eax, 20(%r8)
        movl    %ecx, 28(%r8)
        leal    -1970(%rsi), %eax
        movslq  %eax, %rdx
        imulq   $-1840700269, %rdx, %rdx
        shrq    $32, %rdx
        addl    %eax, %edx
        sarl    $2, %edx
        movl    %eax, %r11d
        sarl    $31, %r11d
        subl    %r11d, %edx
        leal    0(,%rdx,8), %r11d
        subl    %edx, %r11d
        subl    %r11d, %eax
        addl    $4, %eax
        leal    -1(%rsi), %ebx
        testl   %esi, %esi
        je      21f
        movl    %ebx, %edx
        sarl    $2, %edx
        movslq  %ebx, %r11
        imulq   $1374389535, %r11, %r11
        movq    %r11, %r15
        sarq    $37, %r15
        sarl    $31, %ebx
        movl    %ebx, %r12d
        subl    %r15d, %r12d
        addl    %r12d, %edx
        sarq    $39, %r11
        subl    %ebx, %r11d
        addl    %r11d, %edx
        jmp     22f
20:
        movl    $-2147483648, %eax
        subl    %esi, %eax
        cmpl    $-1899, %eax
        jge     28f
        leal    -1900(%rsi), %eax
        movl    %eax, 20(%r8)
        movl    %ecx, 28(%r8)
        leal    -1970(%rsi), %eax
        movslq  %eax, %rdx
        imulq   $-1840700269, %rdx, %rdx
        shrq    $32, %rdx
        addl    %eax, %edx
        sarl    $2, %edx
        movl    %eax, %r11d
        sarl    $31, %r11d
        subl    %r11d, %edx
        leal    0(,%rdx,8), %r11d
        subl    %edx, %r11d
        subl    %r11d, %eax
        addl    $4, %eax
21:
        movl    %esi, %ebx
        negl    %ebx
        movl    %ebx, %edx
        sarl    $2, %edx
        movslq  %ebx, %r11
        imulq   $1374389535, %r11, %r11
        movq    %r11, %r14
        sarq    $37, %r14
        sarl    $31, %ebx
        movl    %ebx, %r12d
        subl    %r14d, %r12d
        addl    %r12d, %edx
        sarq    $39, %r11
        subl    %ebx, %r11d
        addl    %r11d, %edx
        notl    %edx
22:
        leal    -477(%rax,%rdx), %edx
        addl    %ecx, %edx
        movslq  %edx, %rax
        imulq   $-1840700269, %rax, %rax
        shrq    $32, %rax
        addl    %edx, %eax
        sarl    $2, %eax
        movl    %edx, %r11d
        sarl    $31, %r11d
        subl    %r11d, %eax
        leal    0(,%rax,8), %r11d
        subl    %eax, %r11d
        movl    %edx, %eax
        subl    %r11d, %eax
        leal    7(%rax), %edx
        cmovs   %edx, %eax
        movl    %eax, 24(%r8)
        movq    %rdi, %rdx
        shrq    $4, %rdx
        movabsq $655884233731895169, %r11
        movq    %rdx, %rax
        mulq    %r11
        shrq    $3, %rdx
        movl    %edx, 8(%r8)
        imulq   $3600, %rdx, %rdx
        subq    %rdx, %rdi
        movabsq $-8608480567731124087, %rdx
        movq    %rdi, %rax
        mulq    %rdx
        shrq    $5, %rdx
        movl    %edx, 4(%r8)
        movq    %rdx, %r11
        salq    $4, %r11
        subq    %rdx, %r11
        leaq    0(,%r11,4), %rdx
        subq    %rdx, %rdi
        movzbl  %r9b, %r9d
        addl    %edi, %r9d
        movl    %r9d, (%r8)
        movabsq $.Lmon_lengths, %rax
        testl   %r10d, %r10d
        jne     23f
        imull   $-1030792151, %esi, %esi
        addl    $85899344, %esi
        movl    %esi, %edx
        rorl    $2, %edx
        addq    $48, %rax
        cmpl    $42949672, %edx
        jbe     27f
23:
        movl    $0, 16(%r8)
        movl    (%rax), %esi
        cmpl    %ecx, %esi
        jg      26f
24:
        movl    $1, %edx
25:
        subl    %esi, %ecx
        movl    %edx, 16(%r8)
        addq    $1, %rdx
        movl    -4(%rax,%rdx,4), %esi
        cmpl    %ecx, %esi
        jle     25b
26:
        addl    $1, %ecx
        movl    %ecx, 12(%r8)
        movl    $0, 32(%r8)
        movq    %r8, %rax
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
27:
        rorl    $4, %esi
        cmpl    $10737419, %esi
        leaq    -48(%rax), %rdx
        cmovnb  %rdx, %rax
        movl    $0, 16(%r8)
        movl    (%rax), %esi
        cmpl    %ecx, %esi
        jg      26b
        jmp     24b
28:
        movl    %esi, 20(%r8)
29:
        movabsq $.Ltime_errno, %rax
        movl    $75, (%rax)
        xorl    %r8d, %r8d
        movq    %r8, %rax
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
30:
        cmpl    $364, %ecx
        jle     19b
31:
        testl   %eax, %eax
        sete    %al
        movzbl  %al, %eax
        movl    (%r11,%rax,4), %eax
        jmp     16b
32:
        rorl    $4, %eax
        xorl    %edx, %edx
        cmpl    $10737419, %eax
        setb    %dl
        addq    $365, %rdx
        cmpq    %rdx, %rcx
        jge     3b
        jmp     9b
33:
        cmpl    $-2147483648, %esi
        je      29b
        subl    $1, %esi
        movl    $365, %eax
        testb   $3, %sil
        je      36f
34:
        addl    %eax, %ecx
        jns     11b
35:
        testl   %esi, %esi
        js      33b
        subl    $1, %esi
        movl    $365, %eax
        testb   $3, %sil
        jne     34b
36:
        imull   $-1030792151, %esi, %edx
        addl    $85899344, %edx
        movl    %edx, %r10d
        rorl    $2, %r10d
        movl    $366, %eax
        cmpl    $42949672, %r10d
        ja      34b
        rorl    $4, %edx
        xorl    %eax, %eax
        cmpl    $10737419, %edx
        setb    %al
        addl    $365, %eax
        addl    %eax, %ecx
        js      35b
        jmp     11b
37:
        movl    %r13d, %edx
        sarl    $2, %edx
        movslq  %r13d, %r10
        imulq   $1374389535, %r10, %r10
        movq    %r10, %r14
        sarq    $37, %r14
        sarl    $31, %r13d
        movl    %r13d, %r15d
        subl    %r14d, %r15d
        addl    %r15d, %edx
        sarq    $39, %r10
        subl    %r13d, %r10d
        addl    %r10d, %edx
        movl    %esi, %r13d
        subl    $1, %r13d
        js      5b
38:
        movl    %r13d, %esi
        sarl    $2, %esi
        movslq  %r13d, %r10
        imulq   $1374389535, %r10, %r10
        movq    %r10, %r14
        sarq    $37, %r14
        sarl    $31, %r13d
        movl    %r13d, %r15d
        subl    %r14d, %r15d
        addl    %r15d, %esi
        sarq    $39, %r10
        subl    %r13d, %r10d
        addl    %r10d, %esi
        {disp32} jmp 6b
39:
        xorl    %r9d, %r9d
        xorl    %ebx, %ebx
        {disp32} jmp 1b
40:
        xorl    %edx, %edx
        testl   %ecx, %ecx
        je      41f
        movq    (%rax), %rdx
41:
        cmpq    %rbx, %rdx
        setl    %r9b
        {disp32} jmp 1b
        .size   .Ltimesub, .-.Ltimesub

        .p2align 4
        .type   .Llocalsub, @function
.Llocalsub:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        subq    $24, %rsp
        movq    %rdi, %r12
        movq    %rsi, %rdi
        movq    %rdx, %r8
        movq    (%rsi), %rbx
        movq    %rbx, -48(%rbp)
        testq   %r12, %r12
        jne     0f
        movabsq $.Lgmtmem, %rdx
        xorl    %esi, %esi
        movabsq $.Ltimesub, %rax
        addq    $24, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %rbp
        jmpq    *%rax
0:
        cmpb    $0, 16(%r12)
        je      4f
        movq    24(%r12), %rsi
        cmpq    %rsi, %rbx
        jge     4f
1:
        movq    %rsi, %rdx
        subq    %rbx, %rdx
        subq    $1, %rdx
        movabsq $-5893541452261140249, %rdi
        movq    %rdx, %rax
        mulq    %rdi
        shrq    $33, %rdx
        leaq    1(%rdx), %rax
        leaq    (%rax,%rax,4), %rdx
        leaq    (%rdx,%rdx,4), %r13
        salq    $4, %r13
        movabsq $12622780800, %rdx
        imulq   %rdx, %rax
        addq    %rbx, %rax
        movq    %rax, -40(%rbp)
        cmpq    %rax, %rsi
        jle     12f
2:
        xorl    %eax, %eax
3:
        addq    $24, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %rbp
        retq
4:
        movl    4(%r12), %edx
        cmpb    $0, 17(%r12)
        je      5f
        leal    -1(%rdx), %eax
        cltq
        movq    24(%r12,%rax,8), %rax
        cmpq    %rax, %rbx
        jle     5f
        movq    24(%r12), %rsi
        cmpq    %rsi, %rbx
        jl      1b
        movq    %rbx, %rdx
        subq    %rax, %rdx
        subq    $1, %rdx
        movabsq $-5893541452261140249, %rdi
        movq    %rdx, %rax
        mulq    %rdi
        shrq    $33, %rdx
        addq    $1, %rdx
        leaq    (%rdx,%rdx,4), %rax
        leaq    (%rax,%rax,4), %r13
        salq    $4, %r13
        movabsq $12622780800, %rax
        imulq   %rax, %rdx
        movq    %rbx, %rax
        subq    %rdx, %rax
        movq    %rax, -40(%rbp)
        cmpq    %rax, %rsi
        jle     12f
        jmp     2b
5:
        testl   %edx, %edx
        jne     8f
6:
        movslq  25480(%r12), %rax
7:
        leaq    (%rax,%rax,2), %rax
        leaq    (%r12,%rax,8), %rbx
        movq    %r12, %rdx
        movq    18024(%rbx), %rsi
        leaq    -48(%rbp), %rdi
        movabsq $.Ltimesub, %rax
        callq   *%rax
        testq   %rax, %rax
        je      3b
        movzbl  18032(%rbx), %edx
        movl    %edx, 32(%rax)
        addq    $24, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %rbp
        retq
8:
        cmpq    24(%r12), %rbx
        jl      6b
        movl    $1, %eax
9:
        cmpl    %edx, %eax
        jge     10f
        leal    (%rax,%rdx), %esi
        sarl    %esi
        movslq  %esi, %rdi
        cmpq    24(%r12,%rdi,8), %rbx
        jge     11f
        movl    %esi, %edx
        jmp     9b
10:
        subl    $1, %eax
        cltq
        movzbl  16024(%r12,%rax), %eax
        jmp     7b
11:
        leal    1(%rsi), %eax
        jmp     9b
12:
        movl    4(%r12), %edi
        leal    -1(%rdi), %edx
        movslq  %edx, %rdx
        cmpq    %rax, 24(%r12,%rdx,8)
        jl      2b
        movq    %r8, %rdx
        leaq    -40(%rbp), %rsi
        movq    %r12, %rdi
        movabsq $.Llocalsub, %rax
        callq   *%rax
        testq   %rax, %rax
        je      2b
        movslq  20(%rax), %rdx
        leaq    (%rdx,%r13), %rcx
        cmpq    24(%r12), %rbx
        jge     13f
        movq    %rdx, %rcx
        subq    %r13, %rcx
13:
        movl    $2147483648, %edx
        addq    %rcx, %rdx
        shrq    $32, %rdx
        jne     2b
        movl    %ecx, 20(%rax)
        addq    $24, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %rbp
        retq
        .size   .Llocalsub, .-.Llocalsub

        .p2align 4
        .type   .Lgetoffset, @function
.Lgetoffset:
        movq    %rdi, %rax
        movsbl  (%rdi), %edx
        cmpb    $45, %dl
        jne     0f
        movsbl  1(%rdi), %edx
        addq    $1, %rax
        movl    $1, %edi
        jmp     2f
0:
        cmpb    $43, %dl
        jne     1f
        movsbl  1(%rdi), %edx
        addq    $1, %rax
        xorl    %edi, %edi
        jmp     2f
1:
        testq   %rdi, %rdi
        je      3f
        xorl    %edi, %edi
2:
        subl    $48, %edx
        cmpl    $9, %edx
        jbe     5f
3:
        xorl    %eax, %eax
        retq
4:
        leal    (%rdx,%rdx,4), %edx
        leal    (%rcx,%rdx,2), %edx
        cmpl    $167, %edx
        jg      3b
5:
        movq    %rax, %r8
        addq    $1, %rax
        movsbl  (%rax), %ecx
        subl    $48, %ecx
        cmpl    $9, %ecx
        jbe     4b
        testl   %edx, %edx
        js      3b
        movslq  %edx, %rdx
        imulq   $3600, %rdx, %rdx
        movq    %rdx, (%rsi)
        cmpb    $58, (%rax)
        jne     8f
        movsbl  1(%rax), %r9d
        leal    -48(%r9), %eax
        addq    $2, %r8
        xorl    %ecx, %ecx
        cmpl    $9, %eax
        ja      3b
        leal    (%rcx,%rcx,4), %eax
        leal    -48(%r9,%rax,2), %ecx
        cmpl    $59, %ecx
        jg      3b
6:
        leaq    1(%r8), %rax
        movsbl  1(%r8), %r9d
        leal    -48(%r9), %r10d
        cmpl    $9, %r10d
        ja      7f
        movq    %rax, %r8
        leal    (%rcx,%rcx,4), %eax
        leal    -48(%r9,%rax,2), %ecx
        cmpl    $59, %ecx
        jg      3b
        jmp     6b
7:
        testl   %ecx, %ecx
        js      3b
        imull   $60, %ecx, %ecx
        movslq  %ecx, %rcx
        addq    %rdx, %rcx
        movq    %rcx, (%rsi)
        cmpb    $58, (%rax)
        je      11f
8:
        testb   %dil, %dil
        je      10f
9:
        negq    (%rsi)
        retq
10:
        retq
11:
        movsbl  1(%rax), %r9d
        leal    -48(%r9), %eax
        cmpl    $9, %eax
        ja      3b
        leaq    2(%r8), %rax
        xorl    %edx, %edx
12:
        leal    (%rdx,%rdx,4), %edx
        leal    -48(%r9,%rdx,2), %edx
        cmpl    $60, %edx
        jg      3b
        addq    $1, %rax
        movsbl  (%rax), %r9d
        leal    -48(%r9), %r8d
        cmpl    $9, %r8d
        jbe     12b
        testl   %edx, %edx
        js      3b
        movslq  %edx, %rdx
        addq    %rcx, %rdx
        movq    %rdx, (%rsi)
        testb   %dil, %dil
        jne     9b
        jmp     10b
        .size   .Lgetoffset, .-.Lgetoffset

        .p2align 4
        .type   .Lgetrule, @function
.Lgetrule:
        movq    %rdi, %rax
        movq    %rsi, %rcx
        movsbl  (%rdi), %edx
        cmpb    $74, %dl
        jne     2f
        movl    $0, (%rsi)
        movsbl  1(%rdi), %edx
        subl    $48, %edx
        cmpl    $9, %edx
        ja      1f
        addq    $1, %rax
0:
        addq    $1, %rax
        movsbl  (%rax), %esi
        subl    $48, %esi
        cmpl    $9, %esi
        ja      13f
        leal    (%rdx,%rdx,4), %edx
        leal    (%rsi,%rdx,2), %edx
        cmpl    $365, %edx
        jle     0b
1:
        xorl    %eax, %eax
        retq
2:
        cmpb    $77, %dl
        jne     4f
        movl    $2, (%rsi)
        movsbl  1(%rdi), %esi
        leal    -48(%rsi), %edx
        cmpl    $9, %edx
        ja      1b
        addq    $1, %rax
        xorl    %edx, %edx
3:
        leal    (%rdx,%rdx,4), %edx
        leal    -48(%rsi,%rdx,2), %edx
        cmpl    $12, %edx
        jg      1b
        leaq    1(%rax), %rdi
        movsbl  1(%rax), %esi
        leal    -48(%rsi), %r8d
        cmpl    $9, %r8d
        ja      6f
        movq    %rdi, %rax
        jmp     3b
4:
        subl    $48, %edx
        cmpl    $9, %edx
        ja      1b
        movl    $1, (%rsi)
        testq   %rdi, %rdi
        je      1b
        movsbl  (%rdi), %edx
        subl    $48, %edx
        cmpl    $9, %edx
        ja      1b
5:
        addq    $1, %rax
        movsbl  (%rax), %esi
        subl    $48, %esi
        cmpl    $9, %esi
        ja      10f
        leal    (%rdx,%rdx,4), %edx
        leal    (%rsi,%rdx,2), %edx
        cmpl    $365, %edx
        jle     5b
        xorl    %eax, %eax
        retq
6:
        testl   %edx, %edx
        jle     1b
        movl    %edx, 12(%rcx)
        cmpb    $46, (%rdi)
        jne     1b
        movsbl  1(%rdi), %esi
        leal    -48(%rsi), %edx
        cmpl    $9, %edx
        ja      1b
        addq    $2, %rax
        xorl    %edx, %edx
7:
        leal    (%rdx,%rdx,4), %edx
        leal    -48(%rsi,%rdx,2), %edx
        cmpl    $5, %edx
        jg      1b
        leaq    1(%rax), %rdi
        movsbl  1(%rax), %esi
        leal    -48(%rsi), %r8d
        cmpl    $9, %r8d
        ja      8f
        movq    %rdi, %rax
        jmp     7b
8:
        testl   %edx, %edx
        jle     1b
        movl    %edx, 8(%rcx)
        cmpb    $46, (%rdi)
        jne     1b
        movsbl  1(%rdi), %esi
        leal    -48(%rsi), %edx
        cmpl    $9, %edx
        ja      1b
        addq    $2, %rax
        xorl    %edx, %edx
9:
        leal    (%rdx,%rdx,4), %edx
        leal    -48(%rsi,%rdx,2), %edx
        cmpl    $6, %edx
        jg      1b
        addq    $1, %rax
        movsbl  (%rax), %esi
        leal    -48(%rsi), %edi
        cmpl    $9, %edi
        jbe     9b
10:
        testl   %edx, %edx
        js      1b
11:
        movl    %edx, 4(%rcx)
        cmpb    $47, (%rax)
        jne     12f
        leaq    1(%rax), %rdi
        leaq    16(%rcx), %rsi
        movabsq $.Lgetoffset, %rax
        jmpq    *%rax
12:
        movq    $7200, 16(%rcx)
        retq
13:
        testl   %edx, %edx
        jg      11b
        xorl    %eax, %eax
        retq
        .size   .Lgetrule, .-.Lgetrule

        .section .rodata.str1.1,"aMS",@progbits,1

        .type   .LC0, @object
.LC0:
        .string "posixrules"
        .size .LC0, .-.LC0

        .section .text,"ax",@progbits

        .p2align 4
        .type   .Ltzparse, @function
.Ltzparse:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        subq    $168, %rsp
        movq    %rdi, %r13
        movq    %rsi, %rbx
        testb   %dl, %dl
        je      3f
        leaq    3(%rdi), %r15
        movq    $0, -128(%rbp)
        movq    $4, -152(%rbp)
        movq    $3, -136(%rbp)
0:
        xorl    %edx, %edx
        movq    %rbx, %rsi
        movabsq $.LC0, %rdi
        movabsq $.Ltzload, %rax
        callq   *%rax
        movl    %eax, %ecx
        testl   %eax, %eax
        je      12f
1:
        xorl    %eax, %eax
2:
        addq    $168, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
3:
        movzbl  (%rdi), %eax
        cmpb    $60, %al
        jne     5f
        movsbl  1(%rdi), %eax
        addq    $1, %r13
        movq    %r13, %rdi
        testl   %eax, %eax
        je      1b
        movq    %rdi, %r15
        addq    $1, %rdi
        cmpl    $62, %eax
        je      61f
4:
        movsbl  (%rdi), %eax
        testl   %eax, %eax
        je      1b
        movq    %rdi, %r15
        addq    $1, %rdi
        cmpl    $62, %eax
        jne     4b
        jmp     61f
5:
        testb   %al, %al
        je      1b
6:
        cmpb    $45, %al
        jg      11f
        cmpb    $42, %al
        jg      8f
7:
        addq    $1, %rdi
        movzbl  (%rdi), %eax
        testb   %al, %al
        jne     6b
8:
        movq    %rdi, %rax
        subq    %r13, %rax
        movq    %rax, -136(%rbp)
9:
        movq    -136(%rbp), %r14
        testq   %r14, %r14
        je      1b
10:
        leaq    -128(%rbp), %rsi
        movabsq $.Lgetoffset, %rax
        callq   *%rax
        movq    %rax, %r15
        testq   %rax, %rax
        je      1b
        leaq    1(%r14), %rax
        movq    %rax, -152(%rbp)
        cmpq    $512, %rax
        ja      1b
        jmp     0b
11:
        subl    $48, %eax
        cmpb    $9, %al
        ja      7b
        movq    %rdi, %rax
        subq    %r13, %rax
        movq    %rax, -136(%rbp)
        {disp8} jmp 9b
12:
        movzbl  (%r15), %eax
        testb   %al, %al
        je      23f
        cmpb    $60, %al
        je      58f
        movq    %r15, %rdi
13:
        cmpb    $45, %al
        jg      27f
        cmpb    $42, %al
        jg      15f
14:
        addq    $1, %rdi
        movzbl  (%rdi), %eax
        testb   %al, %al
        jne     13b
15:
        movq    %rdi, %rax
        subq    %r15, %rax
        movq    %rax, -144(%rbp)
16:
        movq    -144(%rbp), %rax
        testq   %rax, %rax
        je      1b
17:
        movq    -152(%rbp), %rsi
        leaq    1(%rax,%rsi), %rax
        movq    %rax, -152(%rbp)
        cmpq    $512, %rax
        ja      1b
        movzbl  (%rdi), %eax
        cmpb    $59, %al
        ja      18f
        movabsq $-576478344489467906, %rdx
        btq     %rax, %rdx
        jnc     28f
18:
        movl    %ecx, -156(%rbp)
        leaq    -120(%rbp), %rsi
        movabsq $.Lgetoffset, %rax
        callq   *%rax
        movq    %rax, %rdi
        movl    -156(%rbp), %ecx
        testq   %rax, %rax
        je      1b
        movzbl  (%rdi), %eax
        cmpb    $44, %al
        jne     29f
19:
        movl    %ecx, -156(%rbp)
        addq    $1, %rdi
        leaq    -112(%rbp), %rsi
        movabsq $.Lgetrule, %r11
        callq   *%r11
        testq   %rax, %rax
        je      1b
        cmpb    $44, (%rax)
        jne     1b
        leaq    1(%rax), %rdi
        leaq    -80(%rbp), %rsi
        callq   *%r11
        testq   %rax, %rax
        je      1b
        cmpb    $0, (%rax)
        jne     1b
        movl    $2, 8(%rbx)
        movq    -128(%rbp), %rax
        movq    %rax, -168(%rbp)
        negq    %rax
        movq    %rax, 18024(%rbx)
        movb    $0, 18032(%rbx)
        movl    $0, 18036(%rbx)
        xorl    %edi, %edi
        movw    %di, 18040(%rbx)
        movq    -120(%rbp), %rax
        movq    %rax, -176(%rbp)
        negq    %rax
        movq    %rax, 18048(%rbx)
        movb    $1, 18056(%rbx)
        movl    -136(%rbp), %eax
        addl    $1, %eax
        movl    %eax, 18060(%rbx)
        xorl    %r8d, %r8d
        movw    %r8w, 18064(%rbx)
        xorl    %r14d, %r14d
        movl    $1970, %r9d
        movabsq $-9223372036823239808, %r10
        movabsq $-9223372036823153408, %rdi
        movl    -156(%rbp), %ecx
20:
        movl    %r9d, %r11d
        subl    $1, %r9d
        movq    $-31536000, %r12
        movq    %r10, %rsi
        movl    $31536000, %eax
        testb   $3, %r9b
        jne     21f
        imull   $-1030792151, %r9d, %edx
        movl    %edx, %r8d
        rorl    $2, %r8d
        movq    $-31622400, %r12
        movq    %rdi, %rsi
        movl    $31622400, %eax
        cmpl    $42949672, %r8d
        jbe     57f
21:
        cmpq    %rsi, %r14
        jge     37f
22:
        leal    400(%r11), %eax
        movl    %eax, -156(%rbp)
        jmp     38f
23:
        movabsq $4294967296, %rax
        movq    %rax, 4(%rbx)
        movq    -128(%rbp), %rax
        negq    %rax
        movq    %rax, 18024(%rbx)
        movb    $0, 18032(%rbx)
        movl    $0, 18036(%rbx)
        xorl    %eax, %eax
        movw    %ax, 18040(%rbx)
        movl    $0, 25480(%rbx)
        movq    $0, -144(%rbp)
24:
        movl    -152(%rbp), %eax
        movl    %eax, 12(%rbx)
        leaq    24168(%rbx), %rdx
        xorl    %eax, %eax
25:
        movzbl  0(%r13,%rax), %ecx
        movb    %cl, 24168(%rbx,%rax)
        addq    $1, %rax
        cmpq    -136(%rbp), %rax
        jne     25b
        addq    %rax, %rdx
        movb    $0, (%rdx)
        movl    $1, %eax
        cmpq    $0, -144(%rbp)
        je      2b
        xorl    %eax, %eax
26:
        movzbl  (%r15,%rax), %ecx
        movb    %cl, 1(%rdx,%rax)
        movq    %rax, %rcx
        addq    $1, %rax
        cmpq    %rax, -144(%rbp)
        jne     26b
        movb    $0, 2(%rdx,%rcx)
        movl    $1, %eax
        jmp     2b
27:
        subl    $48, %eax
        cmpb    $9, %al
        ja      14b
        movq    %rdi, %rax
        subq    %r15, %rax
        movq    %rax, -144(%rbp)
        jmp     16b
28:
        movq    -128(%rbp), %rax
        subq    $3600, %rax
        movq    %rax, -120(%rbp)
        movzbl  (%rdi), %eax
        cmpb    $44, %al
        je      19b
29:
        cmpb    $59, %al
        je      19b
        testb   %al, %al
        jne     1b
        movl    4(%rbx), %ecx
        movq    -128(%rbp), %rdi
        testl   %ecx, %ecx
        jle     35f
        leaq    16024(%rbx), %rax
        leal    -1(%rcx), %edx
        leaq    16025(%rbx,%rdx), %rsi
30:
        movzbl  (%rax), %edx
        leaq    (%rdx,%rdx,2), %rdx
        leaq    (%rbx,%rdx,8), %rdx
        cmpb    $0, 18032(%rdx)
        jne     31f
        movq    18024(%rdx), %rdx
        negq    %rdx
        jmp     32f
31:
        addq    $1, %rax
        cmpq    %rax, %rsi
        jne     30b
        xorl    %edx, %edx
32:
        movl    %ecx, %esi
        xorl    %eax, %eax
33:
        movzbl  16024(%rbx,%rax), %ecx
        leaq    (%rcx,%rcx,2), %r8
        leaq    (%rbx,%r8,8), %r9
        movzbl  18032(%r9), %r8d
        movb    %r8b, 16024(%rbx,%rax)
        cmpb    $0, 18041(%r9)
        je      36f
34:
        leaq    (%rcx,%rcx,2), %rcx
        movq    18024(%rbx,%rcx,8), %rcx
        negq    %rcx
        testb   %r8b, %r8b
        cmove   %rcx, %rdx
        addq    $1, %rax
        cmpq    %rax, %rsi
        jne     33b
35:
        negq    %rdi
        movq    %rdi, 18024(%rbx)
        movb    $0, 18032(%rbx)
        movl    $0, 18036(%rbx)
        xorl    %edx, %edx
        movw    %dx, 18040(%rbx)
        movq    -120(%rbp), %rax
        negq    %rax
        movq    %rax, 18048(%rbx)
        movb    $1, 18056(%rbx)
        movl    -136(%rbp), %eax
        addl    $1, %eax
        movl    %eax, 18060(%rbx)
        xorl    %ecx, %ecx
        movw    %cx, 18064(%rbx)
        movl    $2, 8(%rbx)
        movl    $0, 25480(%rbx)
        jmp     24b
36:
        movq    %rdi, %r9
        subq    %rdx, %r9
        addq    %r9, 24(%rbx,%rax,8)
        jmp     34b
37:
        subq    %rax, %r14
        cmpl    $1770, %r9d
        jne     20b
        movl    $2171, -156(%rbp)
        xorl    %r12d, %r12d
38:
        movl    $0, 25480(%rbx)
        movl    %r9d, %edi
        movq    -168(%rbp), %rax
        subq    -176(%rbp), %rax
        movq    %rax, -184(%rbp)
        movq    %r15, %r8
        movq    %r13, %r10
        movq    %rbx, %r15
39:
        movl    $31536000, %r13d
        testb   $3, %dil
        jne     40f
        imull   $-1030792151, %edi, %eax
        movl    %eax, %edx
        rorl    $2, %edx
        movl    $31622400, %r13d
        cmpl    $42949672, %edx
        jbe     56f
40:
        movq    %r10, -208(%rbp)
        movl    %ecx, -192(%rbp)
        movq    %r8, -200(%rbp)
        movl    %r9d, -188(%rbp)
        movq    -168(%rbp), %rdx
        leaq    -112(%rbp), %rsi
        movl    %edi, -160(%rbp)
        movabsq $.Ltranstime, %rax
        callq   *%rax
        movq    %rax, %rbx
        movq    -176(%rbp), %rdx
        leaq    -80(%rbp), %rsi
        movl    -160(%rbp), %edi
        movabsq $.Ltranstime, %rax
        callq   *%rax
        movq    %rax, %rsi
        cmpq    %rax, %rbx
        movl    -160(%rbp), %edi
        movl    -188(%rbp), %r9d
        movq    -200(%rbp), %r8
        movl    -192(%rbp), %ecx
        movq    -208(%rbp), %r10
        jle     41f
        movq    %rbx, %rdx
        jmp     42f
41:
        jge     48f
        movq    %rsi, %rdx
        subq    %rbx, %rdx
        movq    -184(%rbp), %rax
        addq    %r13, %rax
        cmpq    %rax, %rdx
        jge     48f
        movq    %rsi, %rdx
        movq    %rbx, %rax
42:
        cmpl    $1998, %ecx
        jle     44f
        movq    %r10, %r13
        movq    %r15, %rbx
        movq    %r8, %r15
        movl    %ecx, 4(%rbx)
43:
        subl    %r9d, %edi
        cmpl    $400, %edi
        jle     24b
        movl    $257, %esi
        movw    %si, 16(%rbx)
        jmp     24b
44:
        addq    %r12, %rax
        movabsq $9223372036854775807, %r11
        subq    %rax, %r11
        cmpq    %r14, %r11
        setl    %r11b
        testq   %rax, %rax
        js      55f
        testb   %r11b, %r11b
        jne     54f
45:
        movslq  %ecx, %r11
        addq    %r14, %rax
        movq    %rax, 24(%r15,%r11,8)
        cmpq    %rsi, %rbx
        setle   16024(%r15,%r11)
        addl    $1, %ecx
        movslq  %ecx, %r11
46:
        leaq    (%r12,%rdx), %rax
        movabsq $9223372036854775807, %rdx
        subq    %rax, %rdx
        cmpq    %r14, %rdx
        setl    %dl
        testq   %rax, %rax
        js      53f
        testb   %dl, %dl
        jne     52f
47:
        addq    %r14, %rax
        movq    %rax, 24(%r15,%r11,8)
        cmpq    %rsi, %rbx
        setg    16024(%r15,%r11)
        leal    401(%rdi), %eax
        movl    %eax, -156(%rbp)
        addl    $1, %ecx
48:
        addq    %r13, %r12
        movabsq $9223372036854775807, %rax
        subq    %r12, %rax
        cmpq    %r14, %rax
        setl    %al
        testq   %r12, %r12
        jns     49f
        movabsq $-9223372036854775808, %rax
        subq    %r12, %rax
        cmpq    %r14, %rax
        setg    %al
49:
        testb   %al, %al
        je      51f
        movq    %r10, %r13
        movq    %r15, %rbx
        movq    %r8, %r15
        movl    %ecx, 4(%rbx)
        testl   %ecx, %ecx
        jne     43b
50:
        movdqu  18048(%rbx), %xmm0
        movups  %xmm0, 18024(%rbx)
        movq    18064(%rbx), %rax
        movq    %rax, 18040(%rbx)
        movl    $1, 8(%rbx)
        jmp     24b
51:
        addq    %r12, %r14
        addl    $1, %edi
        xorl    %r12d, %r12d
        cmpl    %edi, -156(%rbp)
        jg      39b
        movq    %r10, %r13
        movq    %r15, %rbx
        movq    %r8, %r15
        movl    %ecx, 4(%rbx)
        testl   %ecx, %ecx
        jne     43b
        jmp     50b
52:
        movq    %r14, 24(%r15,%r11,8)
        jmp     48b
53:
        movabsq $-9223372036854775808, %rdx
        subq    %rax, %rdx
        cmpq    %r14, %rdx
        setg    %dl
        testb   %dl, %dl
        jne     52b
        jmp     47b
54:
        movslq  %ecx, %r11
        movq    %r14, 24(%r15,%r11,8)
        jmp     46b
55:
        movabsq $-9223372036854775808, %r11
        subq    %rax, %r11
        cmpq    %r14, %r11
        setg    %r11b
        testb   %r11b, %r11b
        jne     54b
        jmp     45b
56:
        rorl    $4, %eax
        cmpl    $10737419, %eax
        sbbq    %r13, %r13
        andl    $86400, %r13d
        addq    $31536000, %r13
        jmp     40b
57:
        movl    %edx, %eax
        rorl    $4, %eax
        cmpl    $10737419, %eax
        sbbq    %r12, %r12
        andq    $-86400, %r12
        subq    $31536000, %r12
        cmpl    $10737418, %eax
        cmova   %r10, %rsi
        cmpl    $10737419, %eax
        sbbq    %rax, %rax
        andl    $86400, %eax
        addq    $31536000, %rax
        cmpq    %rsi, %r14
        jge     37b
        jmp     22b
58:
        movsbl  1(%r15), %eax
        addq    $1, %r15
        movq    %r15, %rdi
        testl   %eax, %eax
        je      1b
        movq    %rdi, %rdx
        addq    $1, %rdi
        cmpl    $62, %eax
        je      60f
59:
        movsbl  (%rdi), %eax
        testl   %eax, %eax
        je      1b
        movq    %rdi, %rdx
        addq    $1, %rdi
        cmpl    $62, %eax
        jne     59b
60:
        subq    %r15, %rdx
        movq    %rdx, -144(%rbp)
        movq    -144(%rbp), %rax
        testq   %rax, %rax
        je      1b
        jmp     17b
61:
        subq    %r13, %r15
        movq    %r15, -136(%rbp)
        movq    -136(%rbp), %r14
        testq   %r14, %r14
        je      1b
        {disp32} jmp 10b
        .size   .Ltzparse, .-.Ltzparse

        .section .rodata.str1.1,"aMS",@progbits,1

        .type   .LC0, @object
.LC1:
        .string "/etc/localtime"
        .size .L10, .-.LC1

        .section .text,"ax",@progbits

        .p2align 4
        .type   .Ltzload, @function
.Ltzload:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        subq    $84648, %rsp
        movq    %rsi, %r13
        movl    %edx, -84656(%rbp)
        xorl    %edx, %edx
        movw    %dx, 16(%rsi)
        testq   %rdi, %rdi
        jne     1f
        movabsq $.LC1, %rdi
0:
        xorl    %r12d, %r12d
        movl    $2, %eax
        movl    %r12d, %esi
        syscall
        movq    %rax, %rdi
        testq   %rax, %rax
        jns     6f
        movl    %eax, %r12d
        negl    %r12d
        movl    %r12d, %eax
        movabsl %eax, .Ltime_errno
        jmp     12f
1:
        movzbl  (%rdi), %eax
        cmpb    $58, %al
        jne     2f
        movzbl  1(%rdi), %eax
        addq    $1, %rdi
2:
        cmpb    $47, %al
        je      0b
        testb   %al, %al
        je      4f
        xorl    %edx, %edx
3:
        addq    $1, %rdx
        cmpb    $0, (%rdi,%rdx)
        jne     3b
        movl    $36, %r12d
        cmpq    $84531, %rdx
        ja      12f
4:
        movl    $47, %esi
        leaq    -84608(%rbp), %rbx
        movq    %rbx, -84616(%rbp)
        movq    %rbx, %rdx
        movabsq $.Ltzdirslash, %rcx
        leaq    -84589(%rbp), %r8
5:
        movb    %sil, (%rdx)
        cmpq    %r8, %rdx
        je      64f
        addq    $1, %rcx
        addq    $1, %rdx
        movzbl  (%rcx), %esi
        jmp     5b
6:
        testl   %eax, %eax
        jns     8f
7:
        movabsq $.Ltime_errno, %rax
        movl    (%rax), %r12d
        jmp     12f
8:
        leaq    -84608(%rbp), %rsi
        movq    %rsi, -84616(%rbp)
        movl    $59064, %edx
        movl    %r12d, %eax
        syscall
        movq    %rax, %r12
        testq   %rax, %rax
        jns     9f
        negl    %r12d
        movl    %r12d, %eax
        movabsl %eax, .Ltime_errno
        jmp     10f
9:
        movslq  %eax, %rbx
        cmpl    $43, %eax
        jg      11f
        testq   %rbx, %rbx
        movabsl .Ltime_errno, %eax
        movl    $22, %edx
        cmovs   %eax, %edx
        movl    %edx, %r12d
10:
        movl    $3, %eax
        syscall
        testq   %rax, %rax
        jns     12f
        negl    %eax
        movabsl %eax, .Ltime_errno
        jmp     12f
11:
        movl    $3, %eax
        syscall
        testq   %rax, %rax
        jns     13f
        movl    %eax, %r12d
        negl    %r12d
        movl    %r12d, %eax
        movabsl %eax, .Ltime_errno
12:
        movl    %r12d, %eax
        addq    $84648, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        retq
13:
        testl   %eax, %eax
        js      7b
        movl    $2, -84652(%rbp)
        movl    $4, -84624(%rbp)
        leaq    16024(%r13), %rax
        movq    %rax, -84664(%rbp)
        movq    %rbx, %r15
14:
        movzbl  -84584(%rbp), %edx
        movq    %rdx, %rax
        andl    $127, %eax
        movq    %rax, -84632(%rbp)
        movq    -84616(%rbp), %rax
15:
        movq    -84632(%rbp), %rcx
        salq    $8, %rcx
        movzbl  25(%rax), %esi
        movq    %rsi, %rbx
        orq     %rcx, %rbx
        movq    %rbx, -84632(%rbp)
        addq    $1, %rax
        leaq    -84605(%rbp), %rsi
        cmpq    %rsi, %rax
        jne     15b
        leaq    -2147483648(%rbx), %rax
        testb   %dl, %dl
        cmovns  %rbx, %rax
        movq    %rax, -84632(%rbp)
        movzbl  -84588(%rbp), %edx
        movq    %rdx, %rax
        andl    $127, %eax
        movq    %rax, -84640(%rbp)
        movq    -84616(%rbp), %rax
16:
        movq    -84640(%rbp), %rcx
        salq    $8, %rcx
        movzbl  21(%rax), %esi
        movq    %rsi, %rbx
        orq     %rcx, %rbx
        movq    %rbx, -84640(%rbp)
        addq    $1, %rax
        leaq    -84605(%rbp), %rsi
        cmpq    %rsi, %rax
        jne     16b
        leaq    -2147483648(%rbx), %rax
        testb   %dl, %dl
        cmovns  %rbx, %rax
        movq    %rax, -84640(%rbp)
        movzbl  -84580(%rbp), %edx
        movq    %rdx, %rsi
        andl    $127, %esi
        movq    -84616(%rbp), %rax
17:
        salq    $8, %rsi
        movzbl  29(%rax), %ecx
        orq     %rcx, %rsi
        addq    $1, %rax
        leaq    -84605(%rbp), %rbx
        cmpq    %rbx, %rax
        jne     17b
        leaq    -2147483648(%rsi), %rax
        testb   %dl, %dl
        cmovs   %rax, %rsi
        movzbl  -84576(%rbp), %ecx
        movq    %rcx, %rax
        andl    $127, %eax
        movq    -84616(%rbp), %rdx
18:
        salq    $8, %rax
        movzbl  33(%rdx), %edi
        orq     %rdi, %rax
        addq    $1, %rdx
        leaq    -84605(%rbp), %rbx
        cmpq    %rbx, %rdx
        jne     18b
        leaq    -2147483648(%rax), %rdx
        testb   %cl, %cl
        cmovs   %rdx, %rax
        movzbl  -84572(%rbp), %ecx
        movq    %rcx, %rbx
        andl    $127, %ebx
        movq    -84616(%rbp), %rdx
19:
        salq    $8, %rbx
        movzbl  37(%rdx), %edi
        orq     %rdi, %rbx
        addq    $1, %rdx
        leaq    -84605(%rbp), %rdi
        cmpq    %rdi, %rdx
        jne     19b
        leaq    -2147483648(%rbx), %rdx
        testb   %cl, %cl
        cmovs   %rdx, %rbx
        movzbl  -84568(%rbp), %edi
        movq    %rdi, %rcx
        andl    $127, %ecx
        movq    -84616(%rbp), %rdx
20:
        salq    $8, %rcx
        movzbl  41(%rdx), %r8d
        orq     %r8, %rcx
        addq    $1, %rdx
        leaq    -84605(%rbp), %r14
        cmpq    %r14, %rdx
        jne     20b
        leaq    -2147483648(%rcx), %rdx
        testb   %dil, %dil
        cmovs   %rdx, %rcx
        cmpq    $49, %rsi
        jbe     22f
21:
        movl    $22, %r12d
        jmp     12b
22:
        cmpq    $255, %rbx
        ja      21b
        cmpq    $49, %rcx
        ja      21b
        cmpq    $1999, %rax
        ja      21b
        movq    -84632(%rbp), %rdi
        cmpq    %rdi, %rbx
        jne     30f
23:
        movq    -84640(%rbp), %r10
        cmpq    %r10, %rbx
        setne   %dil
        testq   %r10, %r10
        setne   %dl
        testb   %dl, %dil
        jne     21b
        movslq  -84624(%rbp), %r14
        movq    %r14, %rdx
        imulq   %rax, %rdx
        leaq    44(%rax,%rdx), %rdx
        leaq    (%rbx,%rbx,2), %rdi
        leaq    (%rdx,%rdi,2), %rdx
        addq    %rcx, %rdx
        leal    4(%r14), %edi
        movslq  %edi, %rdi
        imulq   %rsi, %rdi
        addq    %rdi, %rdx
        addq    -84632(%rbp), %rdx
        addq    %r10, %rdx
        cmpq    %r15, %rdx
        jg      21b
        movl    %esi, 0(%r13)
        movl    %eax, 4(%r13)
        movl    %ebx, -84620(%rbp)
        movl    %ebx, 8(%r13)
        movslq  %ecx, %r12
        movl    %ecx, 12(%r13)
        testq   %rax, %rax
        je      31f
        leaq    16023(%r13), %r8
        leaq    -84563(%rbp), %r10
        subl    $1, %eax
        movq    %rax, -84672(%rbp)
        movq    -84664(%rbp), %rdi
        addq    %rax, %rdi
        movq    %rdi, -84648(%rbp)
        xorl    %edi, %edi
        leaq    -84564(%rbp), %rax
        movl    %r12d, -84680(%rbp)
        movq    %r15, -84688(%rbp)
24:
        movzbl  (%rax), %r9d
        movq    %r9, %rdx
        andl    $127, %edx
        movq    %r10, %r11
        cmpl    $4, -84624(%rbp)
        jne     67f
        leaq    4(%rax), %r12
25:
        salq    $8, %rdx
        movzbl  (%r11), %r15d
        orq     %r15, %rdx
        addq    $1, %r11
        cmpq    %r12, %r11
        jne     25b
        leaq    -2147483648(%rdx), %r11
        testb   %r9b, %r9b
        cmovs   %r11, %rdx
        movb    $1, 1(%r8)
        testq   %rdi, %rdi
        jne     69f
26:
        xorl    %r9d, %r9d
        movl    $1, %edi
27:
        movq    %rdx, 24(%r13,%r9,8)
        addq    %r14, %rax
        addq    $1, %r8
        addq    %r14, %r10
        cmpq    -84648(%rbp), %r8
        jne     24b
        movslq  -84680(%rbp), %r12
        movq    -84688(%rbp), %r15
        movq    -84664(%rbp), %rdi
        movq    -84672(%rbp), %rdx
        leaq    1(%rax,%rdx), %r9
        xorl    %edx, %edx
28:
        movzbl  (%rax), %r10d
        cmpl    %r10d, -84620(%rbp)
        jle     21b
        cmpb    $0, (%rdi)
        je      29f
        movb    %r10b, 16024(%r13,%rdx)
        addq    $1, %rdx
29:
        addq    $1, %rax
        addq    $1, %rdi
        cmpq    %rax, %r9
        jne     28b
        movl    %edx, 4(%r13)
        jmp     32f
30:
        testq   %rdi, %rdi
        je      23b
        movl    $22, %r12d
        jmp     12b
31:
        movl    $0, 4(%r13)
        testq   %rbx, %rbx
        je      43f
        leaq    -84564(%rbp), %rax
32:
        leaq    18024(%r13), %rdi
        xorl    %r9d, %r9d
        movq    %r15, %r11
33:
        movzbl  (%rax), %r10d
        movq    %r10, %rdx
        andl    $127, %edx
        leaq    1(%rax), %r8
        leaq    4(%rax), %r15
        movq    %r15, -84648(%rbp)
34:
        salq    $8, %rdx
        movzbl  (%r8), %r15d
        orq     %r15, %rdx
        addq    $1, %r8
        cmpq    %r8, -84648(%rbp)
        jne     34b
        leaq    -2147483648(%rdx), %r8
        testb   %r10b, %r10b
        cmovs   %r8, %rdx
        movq    %rdx, (%rdi)
        movzbl  4(%rax), %edx
        cmpb    $1, %dl
        ja      21b
        andl    $1, %edx
        movb    %dl, 8(%rdi)
        movzbl  5(%rax), %edx
        cmpl    %edx, %r12d
        jle     21b
        addq    $6, %rax
        movl    %edx, 12(%rdi)
        addl    $1, %r9d
        addq    $24, %rdi
        cmpl    %r9d, -84620(%rbp)
        jg      33b
        movq    %r11, %r15
35:
        xorl    %edx, %edx
36:
        movzbl  (%rax,%rdx), %edi
        movb    %dil, 24168(%r13,%rdx)
        addq    $1, %rdx
        cmpl    %edx, %r12d
        jg      36b
        leal    -1(%rcx), %edx
        addq    $1, %rdx
        testl   %r12d, %r12d
        movl    $1, %ecx
        cmovle  %rcx, %rdx
        addq    %rdx, %rax
        testl   %r12d, %r12d
        movl    $1, %edx
        cmovg   %r12, %rdx
        movb    $0, 24168(%r13,%rdx)
        testq   %rsi, %rsi
        je      44f
37:
        leaq    4(%r14), %rcx
        movq    %rcx, -84680(%rbp)
        leaq    24680(%r13), %r10
        leaq    (%rax,%r14), %r8
        leaq    1(%rax), %r9
        leal    -1(%rsi), %edx
        leaq    1(%rdx), %rsi
        movq    %rsi, -84672(%rbp)
        xorl    %esi, %esi
        xorl    %edi, %edi
        movq    $0, -84648(%rbp)
38:
        movzbl  (%rax), %ecx
        movq    %rcx, %rdx
        andl    $127, %edx
        movq    %r9, %r11
        cmpl    $4, -84624(%rbp)
        jne     72f
        leaq    4(%rax), %r12
39:
        salq    $8, %rdx
        movzbl  (%r11), %r14d
        orq     %r14, %rdx
        addq    $1, %r11
        cmpq    %r11, %r12
        jne     39b
        leaq    -2147483648(%rdx), %r11
        testb   %cl, %cl
        cmovs   %r11, %rdx
40:
        movzbl  (%r8), %r12d
        movq    %r12, %rcx
        andl    $127, %ecx
        leaq    1(%r8), %r11
        leaq    4(%r8), %r14
        movq    %rax, -84688(%rbp)
41:
        salq    $8, %rcx
        movzbl  (%r11), %eax
        orq     %rax, %rcx
        addq    $1, %r11
        cmpq    %r11, %r14
        jne     41b
        movq    -84688(%rbp), %rax
        leaq    -2147483648(%rcx), %r11
        testb   %r12b, %r12b
        cmovs   %r11, %rcx
        testq   %rdx, %rdx
        js      21b
        movq    %rdx, %r11
        subq    -84648(%rbp), %r11
        cmpq    $2419198, %r11
        jle     21b
        leaq    -1(%rdi), %r11
        cmpq    %rcx, %r11
        je      42f
        addq    $1, %rdi
        cmpq    %rcx, %rdi
        jne     21b
42:
        movq    -84680(%rbp), %rdi
        addq    %rdi, %rax
        movq    %rdx, (%r10)
        movq    %rcx, 8(%r10)
        addq    $1, %rsi
        addq    $16, %r10
        addq    %rdi, %r8
        addq    %rdi, %r9
        cmpq    -84672(%rbp), %rsi
        je      45f
        movq    %rcx, %rdi
        movq    %rdx, -84648(%rbp)
        jmp     38b
43:
        xorl    %edx, %edx
        leaq    -84564(%rbp), %rax
        testq   %rcx, %rcx
        jne     35b
        movb    $0, 24168(%r13,%rdx)
        testq   %rsi, %rsi
        jne     37b
44:
        xorl    %esi, %esi
45:
        movl    %esi, 0(%r13)
        testq   %rbx, %rbx
        je      51f
        leaq    18040(%r13), %rsi
        leal    -1(%rbx), %edx
        leaq    (%rdx,%rdx,2), %rcx
        salq    $3, %rcx
        leaq    18064(%r13,%rcx), %rdi
46:
        cmpq    $0, -84632(%rbp)
        jne     47f
        xorl    %edx, %edx
        jmp     48f
47:
        movzbl  (%rax), %edx
        cmpb    $1, %dl
        ja      21b
        addq    $1, %rax
        andl    $1, %edx
48:
        movb    %dl, (%rsi)
        addq    $24, %rsi
        cmpq    %rsi, %rdi
        jne     46b
        leaq    18041(%r13), %rsi
        leaq    18065(%r13,%rcx), %rcx
49:
        cmpq    $0, -84640(%rbp)
        je      71f
        movzbl  (%rax), %edx
        cmpb    $1, %dl
        ja      21b
        addq    $1, %rax
        andl    $1, %edx
50:
        movb    %dl, (%rsi)
        addq    $24, %rsi
        cmpq    %rsi, %rcx
        jne     49b
51:
        cmpb    $0, -84604(%rbp)
        jne     59f
52:
        cmpq    $2, %r15
        jle     54f
        cmpb    $0, -84656(%rbp)
        je      54f
        cmpb    $10, -84608(%rbp)
        jne     54f
        cmpb    $10, -84609(%rbp,%r15)
        jne     54f
        cmpl    $255, -84620(%rbp)
        je      55f
        movb    $0, -84609(%rbp,%r15)
        xorl    %edx, %edx
        leaq    -25544(%rbp), %rsi
        leaq    -84607(%rbp), %rdi
        movabsq $.Ltzparse, %rax
        callq   *%rax
        testb   %al, %al
        jne     86f
53:
        movl    8(%r13), %eax
        movl    %eax, -84620(%rbp)
54:
        movl    -84620(%rbp), %eax
        testl   %eax, %eax
        je      21b
55:
        movl    4(%r13), %r14d
        cmpl    $1, %r14d
        jle     74f
        movzbl  16024(%r13), %r15d
        movq    %r15, %r9
        leal    -1(%r14), %eax
        movq    %rax, %r10
        movq    %rax, -84616(%rbp)
        xorl    %r11d, %r11d
        movabsq $.Ltypesequiv, %rbx
        movabsq $12622780800, %r12
56:
        movzbl  16025(%r13,%r11), %esi
        movl    %r15d, %edx
        movq    %r13, %rdi
        callq   *%rbx
        testb   %al, %al
        je      84f
        movq    32(%r13,%r11,8), %rax
        subq    24(%r13), %rax
        cmpq    %r12, %rax
        jne     84f
        movb    $1, 16(%r13)
57:
        movslq  %r10d, %r12
        movzbl  16024(%r13,%r12), %r15d
        leal    -2(%r14), %r10d
        movslq  %r10d, %r10
        movabsq $12622780800, %r11
58:
        movzbl  16024(%r13,%r10), %edx
        movl    %r15d, %esi
        movq    %r13, %rdi
        callq   *%rbx
        testb   %al, %al
        je      85f
        movq    24(%r13,%r12,8), %rax
        subq    24(%r13,%r10,8), %rax
        cmpq    %r11, %rax
        jne     85f
        movb    $1, 17(%r13)
        jmp     75f
59:
        movq    %rax, %rdx
        movq    -84616(%rbp), %rbx
        subq    %rbx, %rdx
        subq    %rdx, %r15
        cmpq    %rbx, %rax
        je      61f
        movq    %r15, %rdx
        jbe     62f
        testq   %r15, %r15
        je      61f
        xorl    %edx, %edx
60:
        movzbl  (%rax,%rdx), %ecx
        movq    -84616(%rbp), %rbx
        movb    %cl, (%rbx,%rdx)
        addq    $1, %rdx
        cmpq    %rdx, %r15
        jne     60b
61:
        sall    -84624(%rbp)
        cmpl    $1, -84652(%rbp)
        je      52b
        movl    $1, -84652(%rbp)
        jmp     14b
62:
        testq   %r15, %r15
        je      61b
63:
        subq    $1, %rdx
        movzbl  (%rax,%rdx), %ecx
        movq    -84616(%rbp), %rbx
        movb    %cl, (%rbx,%rdx)
        jne     63b
        jmp     61b
64:
        leaq    -84588(%rbp), %rdx
        testb   %al, %al
        je      66f
65:
        addq    $1, %rdi
        addq    $1, %rdx
        movb    %al, -1(%rdx)
        movzbl  (%rdi), %eax
        testb   %al, %al
        jne     65b
66:
        movb    $0, (%rdx)
        movq    -84616(%rbp), %rdi
        jmp     0b
67:
        leaq    8(%rax), %r12
68:
        salq    $8, %rdx
        movzbl  (%r11), %r15d
        orq     %r15, %rdx
        addq    $1, %r11
        cmpq    %r12, %r11
        jne     68b
        movq    %rdx, %r11
        movabsq $-9223372036854775808, %r15
        addq    %r15, %rdx
        testb   %r9b, %r9b
        cmovns  %r11, %rdx
        movb    $1, 1(%r8)
        testq   %rdi, %rdi
        je      26b
69:
        leaq    -1(%rdi), %r9
        leaq    1(%rdi), %r11
        cmpq    %rdx, 16(%r13,%rdi,8)
        jl      70f
        jg      21b
        movb    $0, (%r8)
        jmp     27b
70:
        movq    %rdi, %r9
        movq    %r11, %rdi
        jmp     27b
71:
        xorl    %edx, %edx
        jmp     50b
72:
        leaq    8(%rax), %r12
73:
        salq    $8, %rdx
        movzbl  (%r11), %r14d
        orq     %r14, %rdx
        addq    $1, %r11
        cmpq    %r11, %r12
        jne     73b
        movq    %rdx, %r11
        movabsq $-9223372036854775808, %r14
        addq    %r14, %rdx
        testb   %cl, %cl
        cmovns  %r11, %rdx
        jmp     40b
74:
        jne     80f
        movzbl  16024(%r13), %r9d
75:
        movl    %r9d, %edx
        xorl    %eax, %eax
76:
        testb   %dl, %dl
        jne     82f
        movzbl  %r9b, %eax
        movzbl  %r9b, %edx
        leaq    (%rdx,%rdx,2), %rdx
        cmpb    $0, 18032(%r13,%rdx,8)
        je      78f
        leaq    0(%r13,%rdx,8), %rdx
77:
        subl    $1, %eax
        jnb     83f
78:
        leaq    18032(%r13), %rdx
        xorl    %eax, %eax
79:
        cmpb    $0, (%rdx)
        je      81f
        addl    $1, %eax
        addq    $24, %rdx
        cmpl    %eax, -84620(%rbp)
        jg      79b
80:
        xorl    %eax, %eax
81:
        movl    %eax, 25480(%r13)
        xorl    %r12d, %r12d
        jmp     12b
82:
        addq    $1, %rax
        cmpl    %eax, %r14d
        jle     80b
        movzbl  16024(%r13,%rax), %edx
        jmp     76b
83:
        subq    $24, %rdx
        cmpb    $0, 18032(%rdx)
        je      81b
        jmp     77b
84:
        addq    $1, %r11
        cmpq    %r11, -84616(%rbp)
        jne     56b
        jmp     57b
85:
        subq    $1, %r10
        cmpl    $-1, %r10d
        jne     58b
        jmp     75b
86:
        movl    12(%r13), %eax
        movl    -25536(%rbp), %esi
        xorl    %r8d, %r8d
        testl   %esi, %esi
        jle     96f
        leaq    -7508(%rbp), %rdi
        leal    -1(%rsi), %edx
        leaq    (%rdx,%rdx,2), %rdx
        movq    -84616(%rbp), %rbx
        leaq    77124(%rbx,%rdx,8), %r14
        leaq    24168(%r13), %r12
87:
        movslq  (%rdi), %r9
        leaq    -1376(%rbp), %rbx
        addq    %rbx, %r9
        movzbl  (%r9), %r10d
        testl   %eax, %eax
        jle     92f
        movq    %r12, %rcx
        xorl    %edx, %edx
88:
        movzbl  (%rcx), %ebx
        cmpb    %r10b, %bl
        jne     90f
        movl    %r10d, %r15d
        movl    $1, %r11d
89:
        testb   %bl, %bl
        je      113f
        movzbl  (%rcx,%r11), %ebx
        addq    $1, %r11
        movzbl  -1(%r9,%r11), %r15d
        cmpb    %r15b, %bl
        je      89b
90:
        addl    $1, %edx
        addq    $1, %rcx
        cmpl    %eax, %edx
        jne     88b
        movl    %eax, %r11d
        testb   %r10b, %r10b
        je      112f
91:
        xorl    %edx, %edx
92:
        addq    $1, %rdx
        cmpb    $0, (%r9,%rdx)
        jne     92b
        leal    (%r11,%rdx), %ecx
        cmpl    $49, %ecx
        jg      95f
        movslq  %r11d, %rdx
        addq    %r12, %rdx
91:
        addq    $1, %r9
        addq    $1, %rdx
        movb    %r10b, -1(%rdx)
        movzbl  (%r9), %r10d
        testb   %r10b, %r10b
        jne     91b
        {disp8} jmp 94f
92:
        testb   %r10b, %r10b
        jne     111f
        xorl    %eax, %eax
93:
        movslq  %eax, %rdx
        addq    %r12, %rdx
        movl    %eax, %r11d
        movl    %eax, %ecx
94:
        movb    $0, (%rdx)
        leal    1(%rcx), %eax
        movl    %r11d, (%rdi)
        addl    $1, %r8d
95:
        addq    $24, %rdi
        cmpq    %rdi, %r14
        jne     87b
96:
        cmpl    %r8d, %esi
        jne     53b
        movl    %eax, 12(%r13)
        movl    4(%r13), %eax
        cmpl    $1, %eax
        jle     101f
        movslq  %eax, %rdx
97:
        movl    %edx, %eax
        leal    -1(%rdx), %edi
        leal    -2(%rdx), %ecx
        movzbl  16022(%r13,%rdx), %ebx
        cmpb    %bl, 16023(%r13,%rdx)
        jne     101f
        movl    %edi, 4(%r13)
        subq    $1, %rdx
        cmpl    $1, %edx
        jg      97b
        movl    -25540(%rbp), %r8d
        movl    8(%r13), %edi
        movl    %edi, -84620(%rbp)
        testl   %r8d, %r8d
        jg      102f
98:
        testl   %esi, %esi
        je      54b
99:
        leal    1(%rdi), %edx
        leal    1(%rsi,%rdi), %r9d
        movslq  %edi, %rax
        leaq    (%rax,%rax,2), %rax
        leaq    0(%r13,%rax,8), %rcx
        xorl    %eax, %eax
100:
        movl    %edx, 8(%r13)
        leaq    -7520(%rbp), %rbx
        leaq    (%rbx,%rax), %r8
        movdqu  (%r8), %xmm0
        movups  %xmm0, 18024(%rcx,%rax)
        movq    16(%r8), %r8
        movq    %r8, 18040(%rcx,%rax)
        addl    $1, %edx
        addq    $24, %rax
        cmpl    %edx, %r9d
        jne     100b
        leal    (%rdi,%rsi), %eax
        movl    %eax, -84620(%rbp)
        jmp     54b
101:
        movl    -25540(%rbp), %r8d
        movl    8(%r13), %edi
        movl    %edi, -84620(%rbp)
        testl   %r8d, %r8d
        jle     98b
        testl   %eax, %eax
        je      106f
        leal    -1(%rax), %ecx
102:
        movslq  %ecx, %rcx
        movq    24(%r13,%rcx,8), %r11
        movslq  0(%r13), %r9
        movq    %r9, %r10
        salq    $4, %r9
        addq    %r13, %r9
        xorl    %ecx, %ecx
103:
        movl    %ecx, %eax
        movq    -84616(%rbp), %rbx
        movq    59088(%rbx,%rcx,8), %rbx
        movq    %r9, %r12
        movl    %r10d, %edx
104:
        subl    $1, %edx
        js      105f
        subq    $16, %r12
        cmpq    24680(%r12), %rbx
        jl      104b
        movslq  %edx, %rdx
        salq    $4, %rdx
        addq    24688(%r13,%rdx), %rbx
105:
        cmpq    %rbx, %r11
        jge     110f
        movl    %edi, -84620(%rbp)
        cmpl    %eax, %r8d
        jle     98b
106:
        movslq  4(%r13), %rcx
        movl    %edi, -84620(%rbp)
        movslq  %eax, %r11
        movq    %r11, %r9
        subq    %rcx, %r9
        movq    -84616(%rbp), %rbx
        leaq    (%rbx,%r9,8), %r10
        movq    %r9, %r11
        addq    %rbx, %r11
        subl    %ecx, %eax
107:
        cmpl    $1999, %ecx
        jg      98b
        movq    59088(%r10,%rcx,8), %rbx
        movslq  0(%r13), %r9
        movq    %r9, %rdx
        salq    $4, %r9
        addq    %r13, %r9
108:
        subl    $1, %edx
        js      109f
        subq    $16, %r9
        cmpq    24680(%r9), %rbx
        jl      108b
        movslq  %edx, %rdx
        salq    $4, %rdx
        addq    24688(%r13,%rdx), %rbx
109:
        movq    %rbx, 24(%r13,%rcx,8)
        movzbl  75088(%rcx,%r11), %edx
        addl    %edi, %edx
        movb    %dl, 16024(%r13,%rcx)
        leal    1(%rcx), %edx
        movl    %edx, 4(%r13)
        addq    $1, %rcx
        leal    (%rax,%rcx), %edx
        cmpl    %edx, %r8d
        jg      107b
        testl   %esi, %esi
        jne     99b
        jmp     54b
110:
        addq    $1, %rcx
        cmpl    %ecx, %r8d
        jg      103b
        movl    %edi, -84620(%rbp)
        testl   %esi, %esi
        jne     99b
        jmp     54b
111:
        xorl    %r11d, %r11d
        jmp     91b
112:
        cmpl    $49, %eax
        jle     93b
        addq    $24, %rdi
        cmpq    %rdi, %r14
        jne     87b
        jmp     96b
113:
        testb   %r15b, %r15b
        jne     90b
        movl    %edx, (%rdi)
        addl    $1, %r8d
        addq    $24, %rdi
        cmpq    %rdi, %r14
        jne     87b
        jmp     96b
        .size   .Ltzload, .-.Ltzload

        .p2align 4
        .type   .Lzoneinit, @function
.Lzoneinit:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r14
        pushq   %r13
        pushq   %r12
        subq    $8, %rsp
        movq    %rdi, %r12
        movq    %rsi, %r13
        testq   %rsi, %rsi
        je      1f
        cmpb    $0, (%rsi)
        jne     2f
        movq    $0, (%rdi)
        movq    $0, 8(%rdi)
        xorl    %eax, %eax
        movw    %ax, 16(%rdi)
        movq    $0, 18024(%rdi)
        movb    $0, 18032(%rdi)
        movl    $0, 18036(%rdi)
        xorl    %edx, %edx
        movw    %dx, 18040(%rdi)
        leaq    24168(%rdi), %rax
        movl    $71, %ecx
        movabsq $.Lgmt, %rdx
0:
        addq    $1, %rdx
        addq    $1, %rax
        movb    %cl, -1(%rax)
        movzbl  (%rdx), %ecx
        testb   %cl, %cl
        jne     0b
        movb    $0, (%rax)
        movl    $0, 25480(%r12)
        xorl    %r14d, %r14d
        movl    %r14d, %eax
        addq    $8, %rsp
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %rbp
        retq
1:
        movl    $1, %edx
        movq    %rdi, %rsi
        xorl    %edi, %edi
        movabsq $.Ltzload, %rax
        addq    $8, %rsp
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %rbp
        jmpq    *%rax
2:
        movl    $1, %edx
        movq    %rdi, %rsi
        movq    %r13, %rdi
        movabsq $.Ltzload, %rax
        callq   *%rax
        movl    %eax, %r14d
        testl   %eax, %eax
        jne     5f
3:
        xorl    %r14d, %r14d
4:
        movl    %r14d, %eax
        addq    $8, %rsp
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %rbp
        retq
5:
        cmpb    $58, 0(%r13)
        je      4b
        xorl    %edx, %edx
        movq    %r12, %rsi
        movq    %r13, %rdi
        movabsq $.Ltzparse, %rax
        callq   *%rax
        testb   %al, %al
        jne     3b
        movl    %r14d, %eax
        addq    $8, %rsp
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %rbp
        retq
        .size   .Lzoneinit, .-.Lzoneinit

        .section .bss,"aw",@nobits

        # struct timespec {
        #   time_t  tv_sec;  (seconds)
        #   long    tv_nsec; (nanosecons)
        # }
        .align 32
        .type .Lts, @object
.Lts:
        .zero 16
         .size .Lts, .-.Lts

        .section .text,"ax",@progbits

        #
        # output should match output of
        # date +"%s"
        # number of seconds since the epoch
        # epoch is 1970-01-01 00:00:00
        #
        .p2align 4
        .type   .Llinux_time, @function
.Llinux_time:
        pushq   %rbp
        movq    %rsp, %rbp
        subq    $8, %rsp        # align stack for call
        xorl    %edi, %edi      # CLOCK_REALTIME
        movabsq $.Lts, %rsi     # &ts (ts is a 16 byte out parameter)
                                # struct timespec {
                                #   time_t   tv_sec;  (seconds)
                                #   long     tv_nsec; (nanoseconds)
                                # };
        movabsq $.Lclock_gettime, %rcx
        call    *(%rcx)         # clock_gettime(CLOCK_REALTIME, &ts)
                                # NOTE: parenthesis required in the call!
        xorq    %rax, %rax      # return 0
        movq    %rbp, %rsp
        popq    %rbp
        retq
        .size   .Llinux_time, .-.Llinux_time

        .section .rodata.str1.1,"aMS",@progbits,1
.LTZ:
        .string "TZ"
.LC3:
        .string ""

        .section .text,"ax",@progbits

        .p2align 4
        .type   .Llocaltime, @function
.Llocaltime:
        pushq   %rbp
        movq    %rsp, %rbp
        pushq   %r15
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbx
        subq    $8, %rsp
        movq    %rdi, %r15
        movabsq $.LTZ, %rdi
        movabsq $.Lgetenv, %rax
        callq   *%rax
        movq    %rax, %rbx
        testq   %rax, %rax
        je      9f
        movzbl  (%rax), %edx
        movl    $1, %r13d
        testb   %dl, %dl
        je      1f
        xorl    %eax, %eax
0:
        addq    $1, %rax
        cmpb    $0, (%rbx,%rax)
        jne     0b
        xorl    %r13d, %r13d
        cmpq    $255, %rax
        setbe   %r13b
1:
        movabsq $.Llcl_is_set, %r14
        movl    (%r14), %eax
        testl   %eax, %eax
        jle     3f
        movabsq $.Llcl_TZname, %rax
        movzbl  (%rax), %ecx
        cmpb    %cl, %dl
        jne     3f
        movq    %rbx, %rsi
2:
        testb   %cl, %cl
        je      10f
        addq    $1, %rax
        addq    $1, %rsi
        movzbl  (%rax), %ecx
        movzbl  (%rsi), %edx
        cmpb    %dl, %cl
        je      2b
3:
        movq    %rbx, %rsi
        movabsq $.Llclmem, %r12
        movq    %r12, %rdi
        movabsq $.Lzoneinit, %rdx
        callq   *%rdx
        testl   %eax, %eax
        je      4f
        movabsq $.LC3, %rsi
        movq    %r12, %rdi
        movabsq $.Lzoneinit, %rdx
        callq   *%rdx
4:
        cmpl    $1, %r13d
        jne     7f
        movzbl  (%rbx), %edx
        movabsq $.Llcl_TZname, %rax
        testb   %dl, %dl
        je      6f
5:
        addq    $1, %rbx
        addq    $1, %rax
        movb    %dl, -1(%rax)
        movzbl  (%rbx), %edx
        testb   %dl, %dl
        jne     5b
6:
        movb    $0, (%rax)
7:
        movl    %r13d, (%r14)
8:
        movabsq $.Ltm, %rcx
        movl    $1, %edx
        movq    %r15, %rsi
        movq    %r12, %rdi
        movabsq $.Llocalsub, %rax
        addq    $8, %rsp
        popq    %rbx
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        popq    %rbp
        jmpq    *%rax
9:
        movabsq $.Llcl_is_set, %r14
        movabsq $.Llclmem, %r12
        movl    (%r14), %edx
        testl   %edx, %edx
        js      8b
        xorl    %esi, %esi
        movq    %r12, %rdi
        movabsq $.Lzoneinit, %rbx
        callq   *%rbx
        movl    $-1, %r13d
        testl   %eax, %eax
        je      7b
        movabsq $.LC3, %rsi
        movq    %r12, %rdi
        callq   *%rbx
        movl    %r13d, (%r14)
        jmp     8b
10:
        movabsq $.Llclmem, %r12
        testb   %dl, %dl
        je      8b
        jmp     3b
        .size   .Llocaltime, .-.Llocaltime

        .section .rodata,"a",@progbits
        .align 8
        .type   .Lyear_lengths, @object
        .size   .Lyear_lengths, 8
.Lyear_lengths:
        .long   365
        .long   366

        .align 32
        .type   .Lmon_lengths, @object
.Lmon_lengths:
        .long   31
        .long   28
        .long   31
        .long   30
        .long   31
        .long   30
        .long   31
        .long   31
        .long   30
        .long   31
        .long   30
        .long   31
        .long   31
        .long   29
        .long   31
        .long   30
        .long   31
        .long   30
        .long   31
        .long   31
        .long   30
        .long   31
        .long   30
        .long   31
        .size   .Lmon_lengths, .-.Lmon_lengths

        .align 16
        .type   .Ltzdirslash, @object
.Ltzdirslash:
        .ascii  "/usr/share/zoneinfo/"
        .size   .Ltzdirslash, 20

        .type   .Lgmt, @object
.Lgmt:
        .string "GMT"
        .size   .Lgmt, 4

        .section .bss,"aw",@nobits

        .align 32
        .type   .Ltm, @object
.Ltm:
        .zero 36
        .size .Ltm, 36

        .align 4
        .type   .Llcl_is_set, @object
.Llcl_is_set:
        .zero 4
        .size .Llcl_is_set, 4

        .align 32
        .type   .Llcl_TZname, @object
.Llcl_TZname:
        .zero 256
        .size .Llcl_TZname, 256

        .align 32
        .type   .Lgmtmem, @object
.Lgmtmem:
        .zero 25488
        .size .Lgmtmem, 25488

        .align 32
        .type   .Llclmem, @object
.Llclmem:
        .zero 25488
        .size .Llclmem, 25488

        .align 4
        .type   .Ltime_errno, @object
.Ltime_errno:
        .zero 4
        .size .Ltime_errno, 4

