################################################################
#
# A simple implementation of the well-known C standard library
# memcpy() function.  This is needed by David M. Gay's
# ASCIIZ<-->double conversion code.
#
# NOTE: buffers pointed to by rdi and rsi MUST NOT OVERLAP
# input:
# rdi is address of destination
# rsi is address of source
# rdx is number of bytes to copy
# output:
# rax is address of destination
#
# rcx is clobbered, holds the number of iterations for 'rep movsb'
#                   (CPU instruction requirement)
################################################################
        .type   .Lmymemcpy,@function
.Lmymemcpy:
        pushq   %rcx                # save rcx
        cld                         # set forward direction
        movq    %rdi, %rax          # save destination address for return value
        movq    %rdx, %rcx          # load rcx with number of bytes to copy from rdx
rep     movsb                       # copy rcx bytes from rsi to rdi
        popq    %rcx                # restore rcx
        retq
        .size   .Lmymemcpy, .-.Lmymemcpy
