        .section .rodata.cst8,"aM",@progbits,8

        .align  8
.Lmyitoa_minneg:
        # minimum 64bit negative number
        .asciz "-9223372036854775808"
        .equ .Lmyitoa_minneg_length, .-.Lmyitoa_minneg

        .section .text,"ax",@progbits

#
# Integer To Ascii
# convert signed integer to ASCIIZ
# expects caller to pass the 64bit signed integer value in rdi,
# and pass the 64bit address of the output buffer in rsi.
# Nothing is returned.
# WARING: buffer size must be >= 22 bytes!
#
        .type   .Lmyitoa, @function
.Lmyitoa:
        pushq   %rbp            # create the
        movq    %rsp, %rbp      # stack frame and allocate 30 bytes of local variables:
        subq    $30, %rsp       # 8 bytes at -8 is flag
                                # value of 1 means negative, 0 means non-negative
                                # 22 bytes at -30 is local temporary buffer
        andq    $-16, %rsp      # force align the stack on 16-byte boundary
        pushq   %r8             # save a copy of r8
        pushfq                  # 8 bytes of flags, maintaining alignment
                                # so stack is 16 byte aligned now for sure
#
# number is in 1st argument (rdi), treated as signed, must be in range
# -9223372036854775808..9223372036854775807
#
        movq    %rsi, %rbx      # the buffer address
        movq    %rdi, %rdx      # the 64 bit signed integer value
        cmpq    $0, %rdx        # ok, 0 will be sign extended
        jge     0f              # if number is non-negative goto following 0
        movq    $1, -8(%rbp)    # mark number as negative
        negq    %rdx            # negate number (so it should be positive integer)
        jno     1f              # if there is no overflow (it is normal negative) then
                                #   goto following 1
                                # else
                                #   number is -9223372036854775808, so special case it
        movabsq $.Lmyitoa_minneg, %rsi        # rsi is pointer to buffer with "-9223372036854775808"
        movq    %rbx, %rdi                    # rdi is pointer to global output buffer
        movabsq $.Lmyitoa_minneg_length, %rcx # rcx is length of .Lmyitoa_minneg string
        cld                     #   set forward direction
rep     movsb                   #   copy the ASCIIZ string from .Lmyitoa_minneg to global
                                #   output buffer
        {disp8} jmp 4f          #   goto following 4
                                # end-if
0:
        movq    $0, -8(%rbp)    # mark number as non-negative
1:
#
#  put the digits in local temporary buffer buffer (they are calculated backwards)
#  by repeatedly dividing by 10.  The remainder each time is in range 0..9 and is
#  the next digit, and adding 48 will make it an ASCII digit.  For example
#  123 / 10 = 12 R 3, so     temporary buffer="3", rcx counter is 1
#  12 / 10 = 1 R 2, so       temporary buffer="32", rcx counter is 2
#  1 / 10 = 0 R 1, so        temporary buffer="321", rcx counter is 3
#  value is 0, so stop computing digits
#
        xorl    %ecx, %ecx      # initialize the counter rcx to zero
                                # rcx counts the number of decimal digits in the ASCIIZ
                                # string
        leaq    -30(%rbp), %rdi # point to the local temporary buffer
2:
        movq    %rdx, %rax      # numerator is rax
        cqto                    # sign-extend rax to rdx:rax which idivq needs
        movl    $10, %r8d       # r8 = 10, the divisor
        idivq   %r8             # rdx:rax = rdx:rax / r8
        xchgq   %rax, %rdx      # get quotient into rdx, remainder into rax
        addb    $48, %al        # convert al to ASCII digit by adding 48
        movb    %al, (%rdi)     # put that ASCII digit into local temporary buffer
        incq    %rdi            # move to next byte in local temporary buffer
        incq    %rcx            # count the digit
        cmpq    $0, %rdx        # if rdx!=0 then
                                #   we still have digits to create so
        jnz     2b              #   goto previous 2 to process more digits
                                # end-if
#
# copy the reversed local temporary buffer contents to a
# non-reversed global output buffer specified by rbx, and we know
# there are rcx digits to copy
#
        movq    %rdi, %rsi      # rsi points to temporary buffer
        movq    %rbx, %rdi      # rdi opints to global buffer (parameter 2)
        # deal with leading sign if necessary
        cmpq    $0, -8(%rbp)    # if the input was negative
        je      3f              # then
        movb    $'-',(%rdi)     #   *rdi='-'
        incq    %rdi            #   rdi++
3:                              # endif
        decq    %rsi            # move to previous byte of local temporary buffer
        movb    (%rsi),%al      # load get byte from temporary buffer
        movb    %al,(%rdi)      # store that byte in global output buffer
        incq    %rdi            # move to next byte of global output buffer
        decq    %rcx            # rcx--, since we processed another byte
        jnz     3b              # if all digits are not processed (rcx!=0) then goto
                                # previous 3
4:
        movb    $0, (%rdi)      # append string terminator
        popfq                   # restore flags
        popq    %r8             # restore r8
        movq    %rbp, %rsp      # free local variables and destroy
        popq    %rbp            # the stack frame
        retq
        .size   .Lmyitoa, .-.Lmyitoa
