#       .set .LOUTPUT_WIDTH, ??
#       .set .LZONE_WIDTH, ??

        .section .rodata.str,"aS",@progbits

        .type   .LTABERRMSG,@object
.LTABERRMSG:
        .asciz  "ERROR: TAB COLUMN IS LESS THAN MINIMUM OUTPUT COLUMN 1"
        .size   .LTABERRMSG, .-.LTABERRMSG

        .type   .LTABERRMSG2,@object
.LTABERRMSG2:
        .asciz  ", USING TAB(1) INSTEAD"
        .size   .LTABERRMSG2, .-.LTABERRMSG2

        .section .text,"ax",@progbits

#
# This procedure implements the Minimal BASIC TAB() function.  The unsigned
# integer argument in rdi is the column number.  If a value less than one is
# specified an error message is printed and the value one is used instead.  If
# the column is greater than .LOUTPUT_WIDTH, then it will be brought into range by
# dividing column by .LOUTPUT_WIDTH and using the remainder as the value for
# column.  Once the column is within the range 1...LOUTPUT_WIDTH inclusive, the
# TAB() function will set the buffer output position to the value specifed by
# the column argument, unless that is less than the buffer output position, in
# which case the current line will be output and then the the buffer output
# position will be set to the value of column.  Note that the TAB() function in
# ECMA-55 Minimal BASIC takes a floating point value and rounds it to an
# integer.  This function is called after that conversion using the integer
# value which is the result of that conversion.  Columns and zones are 1-based.
#
# rdi is arg1, address of the output buffer
# rsi is arg2, address where the buffer output position is stored
# rdx is arg3, address where the output zone is stored
# rcx is arg4, column number value
#
        .type   .Ltab, @function
        .balign 16, 0x90
.Ltab:
        pushq   %rbp                  # create the
        movq    %rsp,%rbp             # stack frame
        subq    $24,%rsp              # reserve room for local copies of arg1, arg2, and arg3 (8 bytes each)
        movq    %rdi,-8(%rbp)         # save a copy of arg1 (address of the output buffer)
        movq    %rsi,-16(%rbp)        # save a copy of arg2 (address where the buffer output position is stored)
        movq    %rdx,-24(%rbp)        # save a copy of arg3 (address where the output zone is stored)
        cmpq    $0, %rcx              # if column number value is > 0  then
        jg      0f                    # goto 0
        movabsq $.LTABERRMSG, %rcx    # rcx = address of error message
        movabsq $.LEBUF,%rdi          # rdi = arg 1 output buffer variable address
        movabsq $.Lebuf_next,%rsi     # rsi = arg 2 output bufpos variable address
        movabsq $.Lcurezone,%rdx      # rdx = arg 3 output zonepos variable address
        movabsq $.Lappendbuffer,%rax  # call the appendbuffer
        callq   *%rax                 # subroutine
        movabsq $.LTABERRMSG2, %rsi   # rsi = address of error message
        movabsq $.Lexception_non_fatal,%r15 # call the non-fatal
        callq   *%r15                 # exception handler subroutine
        movl    $1, %ecx              # override bogus column number value and set it to 1
0:
        movq    %rcx, %rbx            # rbx = copy of column specifed  in rcx
        cmpq    $.LOUTPUT_WIDTH, %rcx # if column specified <= .LOUTPUT_WIDTH then
        jbe     1f                    # goto 1
        movl    $.LOUTPUT_WIDTH, %ecx # rcx = .LOUTPUT_WIDTH value
        movq    %rbx, %rax            # rax = copy of column specifed
        xorl    %edx, %edx            # rdx = 0
        divq    %rcx                  # rax = rdx:rax / rcx  ; rdx = rdx:rax % rcx
        movq    %rdx, %rbx            # move remainder into rbx
1:                                    # at this point rbx contains the actual column number to use
        movq    -16(%rbp), %rax       # rax = address where the buffer position is stored
        cmpq    (%rax), %rbx          # if buffer position >= actual column number to use
        jae     2f                    # goto 2
                                      # otherwise flush output
        movq    -8(%rbp),%rdi         # rdi = arg 1 address of buffer
        movq    -16(%rbp),%rsi        # rsi = arg 2 address of buffer output position variable
        movq    -24(%rbp),%rdx        # rdx = arg 3 address of output zone variable
        movabsq $.Loutputbuffer, %rax # call the outputbuffer
        callq   *%rax                 # subroutine
2:
        movq    %rbx, %rax            # rax = copy of actual column number to use
        movq    -16(%rbp),%rbx        # rbx = address of output buffer position variable
        movq    %rax,(%rbx)           # store actual column number to use
        movl    $.LZONE_WIDTH, %ecx     # rcx = .LZONE_WIDTH value
        xorl    %edx, %edx            # rdx=0
                                      # rdx:rax is 0:actual column number to use
        decl    %eax                  # rax=rax-1    (convert to 0-based column)
        divq    %rcx                  # rax = rdx:rax / rcx  ; rdx = rdx:rax % rcx
                                      # remainder is zone number, but 0-based
        incl    %eax                  # rax=rax+1    (convert to 1-based zone)
        movq    -24(%rbp),%rbx        # rbx = address of output zone variable
        movq    %rax,(%rbx)           # store actual zone number to use
        movq    %rbp,%rsp             # deallocate local variables and
        popq    %rbp                  # destroy stack frame
        retq
        .size   .Ltab, .-.Ltab
