# ---------- start vDSO stuff ---------
# ----------- begin Andrew Lutomirski code ----------
# parse_vdso.c: Linux reference vDSO parser
#
# Written by Andrew Lutomirski, 2011-2014.
#
# This code is meant to be linked in to various programs that run on Linux.
# As such, it is available with as few restrictions as possible.  This file
# is licensed under the Creative Commons Zero License, version 1.0,
# available at http://creativecommons.org/publicdomain/zero/1.0/legalcode
#
# The vDSO is a regular ELF DSO that the kernel maps into user space when
# it starts a program.  It works equally well in statically and dynamically
# linked binaries.
#
# To the extent possible under law, the author(s) have dedicated all
# copyright and related and neighboring rights to this software to the
# public domain worldwide. This software is distributed without any
# warranty.
#
        .section .rodata.str1.1,"aMS",@progbits,1

.LCvdso_clock_gettime_string:
        .string "__vdso_clock_gettime"
.LClinux_two_six_string:
        .string "LINUX_2.6"
.LCnovdso:
        .string "Unable to complete vDSO setup!"

        .section .bss,"aw",@nobits

        .align 32
        .type .Lvdso_info, @object
.Lvdso_info:
        .zero 80
        .size .Lvdso_info, .-.Lvdso_info

        .align 8
        .type .Lclock_gettime, @object
.Lclock_gettime:
        .zero 8
        .size .Lclock_gettime, .-.Lclock_gettime

        .section .text,"ax",@progbits

        .type   .Lvdso_strcmp, @function
.Lvdso_strcmp:
        xorl    %eax, %eax
0:
        movb    (%rdi,%rax), %cl
        movb    (%rsi,%rax), %dl
        testb   %cl, %cl
        je      1f
        incq    %rax
        testb   %dl, %dl
        je      2f
        cmpb    %dl, %cl
        je      0b
        {disp8} jmp 2f
1:
        xorl    %eax, %eax
        testb   %dl, %dl
        setne   %al
        ret
2:
        movl    $1, %eax
        retq
        .size   .Lvdso_strcmp, .-.Lvdso_strcmp

        .type   .Lelf_hash, @function
.Lelf_hash:
        xorl    %eax, %eax
0:
        movzbl  (%rdi), %edx
        testb   %dl, %dl
        je      2f
        salq    $4, %rax
        incq    %rdi
        addq    %rax, %rdx
        movq    %rdx, %rax
        andl    $4026531840, %eax
        je      1f
        movq    %rax, %rcx
        shrq    $24, %rcx
        xorq    %rcx, %rdx
1:
        notq    %rax
        andq    %rdx, %rax
        {disp8} jmp 0b
2:
        retq
        .size   .Lelf_hash, .-.Lelf_hash

        .type   .Lvdso_init_from_sysinfo_ehdr, @function
.Lvdso_init_from_sysinfo_ehdr:
        movabsq $.Lvdso_info, %rax
        cmpb    $2, 4(%rdi)
        movb    $0, (%rax)
        movq    %rdi, %rax
        movabsq %rax, .Lvdso_info+8
        jne     18f
        pushq   %r13
        xorl    %r10d, %r10d
        xorl    %edx, %edx
        xorl    %ecx, %ecx
        movabsq .Lvdso_info+16, %rax
        pushq   %r12
        xorl    %r8d, %r8d
        movabsq $.Lvdso_info, %r9
        pushq   %rbp
        pushq   %rbx
        movq    32(%rdi), %rbp
        movzwl  56(%rdi), %ebx
        addq    %rdi, %rbp
0:
        cmpq    %r8, %rbx
        jbe     3f
        imulq   $56, %r8, %rsi
        addq    %rbp, %rsi
        movl    (%rsi), %r11d
        cmpl    $1, %r11d
        jne     1f
        testb   %cl, %cl
        jne     2f
        movq    8(%rsi), %rax
        movb    $1, %r10b
        movb    $1, %cl
        addq    %rdi, %rax
        subq    16(%rsi), %rax
        {disp8} jmp 2f
1:
        cmpl    $2, %r11d
        jne     2f
        movq    8(%rsi), %rdx
        addq    %rdi, %rdx
2:
        incq    %r8
        {disp8} jmp 0b
3:
        testb   %r10b, %r10b
        je      4f
        movabsq %rax, .Lvdso_info+16
4:
        xorl    $1, %ecx
        testq   %rdx, %rdx
        sete    %al
        orb     %al, %cl
        jne     17f
        addq    $8, %rdx
        xorl    %r11d, %r11d
        xorl    %ebp, %ebp
        xorl    %r13d, %r13d
        xorl    %r10d, %r10d
        xorl    %ebx, %ebx
        xorl    %r12d, %r12d
        xorl    %esi, %esi
        movabsq $.Lvdso_info+32, %rax
        movq    $0, (%rax)
        movq    -16(%rax), %r8
        movq    $0, -8(%rax)
        movq    $0, 32(%rax)
        movq    $0, 40(%rax)
        xorl    %eax, %eax
5:
        movq    -8(%rdx), %rdi
        testq   %rdi, %rdi
        je      11f
        cmpq    $6, %rdi
        je      7f
        jg      6f
        cmpq    $4, %rdi
        je      8f
        cmpq    $5, %rdi
        jne     10f
        movq    (%rdx), %rax
        movb    $1, %cl
        addq    %r8, %rax
        {disp8} jmp 10f
6:
        cmpq    $1879048176, %rdi
        je      9f
        cmpq    $1879048188, %rdi
        jne     10f
        movq    (%rdx), %r10
        movb    $1, %r11b
        addq    %r8, %r10
        {disp8} jmp 10f
7:
        movq    (%rdx), %r12
        movb    $1, %r13b
        addq    %r8, %r12
        {disp8} jmp 10f
8:
        movq    (%rdx), %rsi
        addq    %r8, %rsi
        {disp8} jmp 10f
9:
        movq    (%rdx), %rbx
        movb    $1, %bpl
        addq    %r8, %rbx
10:
        addq    $16, %rdx
        {disp8} jmp 5b
11:
        testb   %cl, %cl
        je      12f
        movabsq %rax, .Lvdso_info+32
12:
        testb   %r13b, %r13b
        je      13f
        movq    %r12, %rax
        movabsq %rax, .Lvdso_info+24
13:
        testb   %bpl, %bpl
        je      14f
        movq    %rbx, %rax
        movabsq %rax, .Lvdso_info+64
14:
        testb   %r11b, %r11b
        je      15f
        movq    %r10, %rax
        movabsq %rax, .Lvdso_info+72
15:
        cmpq    $0, 32(%r9)
        je      17f
        cmpq    $0, 24(%r9)
        je      17f
        testq   %rsi, %rsi
        je      17f
        cmpq    $0, 72(%r9)
        jne     16f
        movabsq $.Lvdso_info+64, %rax
        movq    $0, (%rax)
16:
        movq    (%rsi), %rax
        movl    (%rsi), %edx
        movabsq %rax, .Lvdso_info+56
        leaq    8(%rsi), %rax
        movabsq %rax, .Lvdso_info+40
        leal    2(%rdx), %eax
        leaq    (%rsi,%rax,4), %rax
        movabsq %rax, .Lvdso_info+48
        movabsq $.Lvdso_info, %rax
        movb    $1, (%rax)
17:
        popq    %rbx
        popq    %rbp
        popq    %r12
        popq    %r13
18:
        retq
        .size   .Lvdso_init_from_sysinfo_ehdr, .-.Lvdso_init_from_sysinfo_ehdr

        .type   .Lvdso_sym, @function
.Lvdso_sym:
        pushq   %r15
        xorl    %eax, %eax
        pushq   %r14
        pushq   %r13
        pushq   %r12
        pushq   %rbp
        movq    %rsi, %rbp
        movabsq $.Lvdso_info, %rsi
        pushq   %rbx
        subq    $56, %rsp
        cmpb    $0, (%rsi)
        je      8f
        movabsq $.Lelf_hash, %r8
        movq    %rdi, %rbx
        movabsq $.Lvdso_strcmp, %r15
        call    *%r8
        movq    %rbp, %rdi
        movq    %rax, 32(%rsp)
        call    *%r8
        movl    56(%rsi), %ecx
        xorl    %edx, %edx
        movq    64(%rsi), %r14
        divq    %rcx
        movabsq .Lvdso_info+40, %rax
        movl    (%rax,%rdx,4), %edx
        movabsq .Lvdso_info+24, %rax
        movq    %rax, 16(%rsp)
        movabsq .Lvdso_info+32, %rax
        movq    %rax, 8(%rsp)
        movabsq .Lvdso_info+72, %rax
        movq    %rax, 40(%rsp)
        movabsq .Lvdso_info+48, %rax
        movq    %rax, 24(%rsp)
0:
        testl   %edx, %edx
        je      7f
        movl    %edx, %r12d
        movq    16(%rsp), %rax
        imulq   $24, %r12, %rcx
        leaq    (%rax,%rcx), %r13
        movb    4(%r13), %al
        movl    %eax, %esi
        andl    $15, %esi
        cmpb    $2, %sil
        jne     6f
        shrb    $4, %al
        decl    %eax
        cmpb    $1, %al
        ja      6f
        cmpw    $0, 6(%r13)
        je      6f
        movl    0(%r13), %esi
        movq    %rbp, %rdi
        addq    8(%rsp), %rsi
        call    *%r15
        testl   %eax, %eax
        jne     6f
        testq   %r14, %r14
        jne     2f
1:
        movabsq .Lvdso_info+16, %rax
        addq    8(%r13), %rax
        {disp8} jmp 8f
2:
        movw    (%r14,%r12,2), %di
        movq    40(%rsp), %rax
        andw    $32767, %di
3:
        testb   $1, 2(%rax)
        jne     4f
        movl    4(%rax), %esi
        andw    $32767, %si
        cmpw    %si, %di
        je      5f
4:
        movl    16(%rax), %esi
        testl   %esi, %esi
        je      6f
        addq    %rsi, %rax
        {disp8} jmp 3b
5:
        movl    32(%rsp), %ecx
        cmpl    %ecx, 8(%rax)
        jne     6f
        movl    12(%rax), %esi
        movq    %rbx, %rdi
        movl    (%rax,%rsi), %esi
        addq    8(%rsp), %rsi
        call    *%r15
        testl   %eax, %eax
        je      1b
6:
        movq    24(%rsp), %rax
        movl    (%rax,%r12,4), %edx
        {disp8} jmp 0b
7:
        xorl    %eax, %eax
8:
        addq    $56, %rsp
        popq    %rbx
        popq    %rbp
        popq    %r12
        popq    %r13
        popq    %r14
        popq    %r15
        retq
        .size   .Lvdso_sym, .-.Lvdso_sym

        .type   .Lvdso_init_from_auxv, @function
.Lvdso_init_from_auxv:
0:
        movq    (%rdi), %rax
        movq    %rdi, %rdx
        testq   %rax, %rax
        je      1f
        addq    $16, %rdi
        cmpq    $33, %rax
        jne     0b
        movabsq $.Lvdso_init_from_sysinfo_ehdr, %rax
        movq    8(%rdx), %rdi
        jmpq    *%rax
1:
        movabsq $.Lvdso_info, %rax
        movb    $0, (%rax)
        retq
        .size   .Lvdso_init_from_auxv, .-.Lvdso_init_from_auxv
# ----------- end Andrew Lutomirski code ----------
# ----------- end vDSO stuff ----------
