#
# Written by John Gatewood Ham.  This file is in the Public Domain.
#
# as --64 -n --divide --size-check=error -o dumpstack.o dumpstack.s
        .att_syntax
        .att_mnemonic
        .arch core2,nojumps
        .code64

        .section .data,"aw",@progbits

.LITOXoutbuffer:
        .ascii "\n========================================"
        .ascii "========================================\n"
.LSTACKbuffer:
        .ascii " 8(RSP)=FFFFFFFFFFFFFFFF\n"
        .ascii "16(RSP)=FFFFFFFFFFFFFFFF\n"
        .ascii "24(RSP)=FFFFFFFFFFFFFFFF\n"
        .ascii "32(RSP)=FFFFFFFFFFFFFFFF\n"
        .ascii "40(RSP)=FFFFFFFFFFFFFFFF\n"
        .ascii "48(RSP)=FFFFFFFFFFFFFFFF\n"
        .ascii "56(RSP)=FFFFFFFFFFFFFFFF\n"
        .ascii "64(RSP)=FFFFFFFFFFFFFFFF\n"
        .set .LSTACKbuflen, .-.LSTACKbuffer
.LRSPbuffer:
        .ascii "    RSP=FFFFFFFFFFFFFFFF\n"
        .set .LRSPbuflen, .-.LRSPbuffer
.LRBPbuffer:
        .ascii "    RBP=FFFFFFFFFFFFFFFF\n"
        .set .LRBPbuflen, .-.LRBPbuffer
        .ascii "========================================"
        .ascii "========================================\n\n"
        .set .LITOXoutbuflen, .-.LITOXoutbuffer

        .section .rodata.str1.1,"aMS",@progbits,1

.LHEXTOASC:
        .ascii "0123456789ABCDEF"
        .byte 0

        .section .text,"ax",@progbits

        # first arg char *s is in rdi, must have >=17 bytes....
        # second arg const unsigned long int n is in rsi
        # this is a procedure, nothing is returned
        .local .Litox2
        .type  .Litox2, @function
.Litox2:
        pushq   %rax
        pushq   %rbx
        pushq   %rcx
        pushq   %rdx
        pushq   %r8
        pushq   %r9
        movabsq $.LHEXTOASC, %rcx  # rcx= pointer to array of hex digits
        movq    %rsi, %r9        # local variable j=n
        xorq    %r8, %r8         # local variable i=0
        movq    $15, %rbx        # rbx=15
0:
        movq    %rbx, %rdx       # rdx=15
        subq    %r8, %rdx        # rdx=15-i
        movq    %r9, %rax        # rax=j
        andq    %rbx, %rax       # rax=j&15
        movb    (%rcx,%rax,1), %al    # al=konvert[rax]
        movb    %al, (%rdi,%rdx,1)    # s[15-i]=konvert[rax]
        shrq    $4, %r9          # j>>=4
        incq    %r8              # i++
        cmpq    %rbx, %r8        # if i<=15 then
        jbe     0b               # goto 0
        # warning, does not terminate string!
        # movb    $0, 16(%rdi)     # s[16]=0
        popq    %r9
        popq    %r8
        popq    %rdx
        popq    %rcx
        popq    %rbx
        popq    %rax
        retq
        .size   .Litox2, .-.Litox2

        .globl  dumpstack
        .type   dumpstack, @function
dumpstack:
        pushfq
        pushq   %r11
        pushq   %rdx
        pushq   %rax
        pushq   %rdi
        pushq   %rsi
        # 40 bytes extra
        movabsq $.LRSPbuffer+8,%rdi
        movq    %rsp,%rsi       # rsp
        addq    $40,%rsi
        callq   .Litox2
        movabsq $.LRBPbuffer+8,%rdi
        movq    %rbp,%rsi       # rbp
        callq   .Litox2
        # remember, 32 bytes extra
        movabsq $.LSTACKbuffer+8,%rdi
        movq    48(%rsp),%rsi    # 8(%rsp)
        callq   .Litox2
        addq    $25,%rdi
        movq    56(%rsp),%rsi   # 16(%rsp)
        callq   .Litox2
        addq    $25,%rdi
        movq    64(%rsp),%rsi   # 24(%rsp)
        callq   .Litox2
        addq    $25,%rdi
        movq    72(%rsp),%rsi   # 32(%rsp)
        callq   .Litox2
        addq    $25,%rdi
        movq    80(%rsp),%rsi   # 40(%rsp)
        callq   .Litox2
        addq    $25,%rdi
        movq    88(%rsp),%rsi   # 48(%rsp)
        callq   .Litox2
        addq    $25,%rdi
        movq    96(%rsp),%rsi   # 56(%rsp)
        callq   .Litox2
        addq    $25,%rdi
        movq    104(%rsp),%rsi  # 64(%rsp)
        callq   .Litox2

        # now print the whole thing using 64bit x86-64 Linux-specific
        # system call (tested on kernel version 3.12.8)
        movabsq $.LITOXoutbuffer, %rsi
        movq    $.LITOXoutbuflen, %rdx
        movq    $2, %rdi        # STDERR
        movq    $1, %rax        # __NR_write
        syscall                 # write(STDERR,ITOXoutbuffer,ITOXotbuflen)  (trashes r11)
        popq    %rsi
        popq    %rdi
        popq    %rax
        popq    %rdx
        popq    %r11
        popfq
        retq
        .size   dumpstack, .-dumpstack

