//
// load_textdata.h - This file contains the header file for load_textdata.c
//
// Copyright (C) 2017,2018,2019,2020,2021  John Gatewood Ham
//
// This file is part of ecma55.
//
// ecma55 is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// as published by the Free Software Foundation.
//
// ecma55 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ecma55.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef LOAD_TEXTDATA_H
#define LOAD_TEXTDATA_H
#include <inttypes.h>

#define WRITEWITHNEWLINE(f,k) \
    { \
      fwrite(item_list[k].data, item_list[k].datalength, 1U, f); \
      fputs("\n",f); \
    }

// Warning: This depends on each of the 3 fields being 8 bytes
//          which is true for Linux AMD64.
struct ilist {
  const char *fname;                       // name of text file with assembly code
  const unsigned char *data;               // pointer to buffer that contains that code
  const uint64_t datalength;               // number of bytes in data[] buffer
};
extern volatile struct ilist *item_list;   // pointer to vector of assembly text pointers
void initialize_item_list(void);           // number of elements in item_list[] vector
#endif
